* ===========================================================================
* ⥬  .⮢.   譥 ணࠬ+㪠  PRE_SELL
* ... த  PRE_SPEC
*
* pPre_sell              .
*   cDemoInv            ࠦ ப ⠡   ᬮ ⠡筮 쥪.
*   pCreaPrice          ன ࠢ筨 業.
*   lAddChInv              ᠭ ⮢୮-࠭ᯮ .
*       cCrDetSave      ନ஢ ⠫樨 .
*           lAddChDet   /  .  ப  䠩 ⠫樨.
*           lDelDet       .  ப  ⠫樨.
*   lDeleteInv           . / . ਬ  娢 ⮢.
*   pPreAlloc           ।.   ॠ쭮 㧮筮 
*   pListPreWar         室 ⮢  ।. . ᮪ 㤮⢮७⥩.
*   pReestrAg            -  ६饭 .
*   pLessAll             ਧ ।  ⥪饣 .  ୮ ।.
*   pLoInPre            ᫥⥫    ᫮ ᫮
*   pDeleteGrz             ᫮ ⥬ ᪠
*   pReestrPre           ।⥫ .
*   pDublPre            㡫஢ ।  ।.
*   pAddSarcis             ⮢ࠬ ᯥ.ࠩ 
*   lChNumbPre            ४⮢ 蠯 ।
*   06.2008 ⥣ ० । 㧪.
*   lInpPayNO           । ࠢ筮 ଠ樨     祣 .
*   pPrePrDoc            窨   ⮢ 䠪  
*   pVirt               ८ࠧ ।  㠫 㬥   
* ===========================================================================
#include "laks.ch"

//   冷     ᬮ ⠡.
STAT nOrder:=PR_DAT_NUMBER, nRecNo:=1, cId:=C_PRE_SELL
MEMV cSourSin, cTargSin

* ---------------------------------------------------------------------------
*    .
*   04.2007 ࠢ筨 業  䠩 ﭭ ࠭.
*   06.2007 室  ᯮ짮  codMin  ࠢ筨 ⮢஢
*   06.2008 쭮   ࠧ୮   ꥤ  ⠬
*   02.2009  権  㯯 㬥⮢.
*   07.2014 . ० 筮  蠯 㬥 - F4
PROC pPre_sell()
    LOCA cP:="", cA:="", nQty:=0, cOldCol:=SetColor(), nKeys:=0, aArr, nCount:=0
    LOCA sOp:="0700"
    S_PROC
    J_OPEN

    //   ६  ᪫  묨 ࠡ⠥  ० ।.
    PRIV cSourSin:="  ", cTargSin:="  ", doDat:=Date()

    //  뢠 ᨢ  맮  ⥫ .
    PRIV oTb

    PRIV aArg:={{"      ⨪  ⮡࠭ 㯯 㬥⮢","pPrSwGrDoc(2)",FALSE},;
                {"shF10   ப ⮡࠭  㯯     *","pLocateGr(oTb)",TRUE},;
                {"aF8   祭/몫.  㯯  㬥.","pGroupObj(oTb)",TRUE},;
                {"aF5   ⪠  . 㬥⮢ ஬ ⮡࠭.","pNoGroupObj()",TRUE},;
                {"aF7    ᢮   . 㬥⮢","pPrSwGrDoc()",FALSE},;
                {"aF9   /몫.  ᫮ ᪠  ⥪. F5","pLoInPre(1)",TRUE},;
                {"aF10  ⨥  ⮪  ⡮ . 㯯","pGroupObj(oTb,.F.)",TRUE}}

    PRIV aAr1:={{"       ᯨ᪠ 㤮⢮७ .","pListPreWar(1)",FALSE},;   //  PRE
                {"       ।⥫ .   .","pListPreWar(2)",FALSE},;   //  PRE
                {"^F10   ।..  ..","pListPreWar(3)",FALSE},;   //  PRE
                {"F4    . , ᭮  㣨 ४⮢","lChNumbPre()",TRUE},;      //  PRE
                {"sF4    ࠬ஢ ᯥ毥  䠪","pVirt(5)",FALSE},;         //  PRE
                {"sF5    .ᯥ毥.  ।","pVirt(6)",FALSE},;         //  PRE
                {"sF9      ⮢ࠬ ᯥ.ࠩ ","pAddSarcis()",TRUE},;      //  PRE
                {"^F6   樠஢.   ।","pSpAccInv()",FALSE},;      //  UNI
                {"      䨪樨 ࠧ ଠ⮢  .","ppSpecif()",FALSE}}        //  PRE_SPEC

    aArr    := {{"       ਧ ।  ⥪. ","pLessAll(1)",TRUE},;
                {"....  த  ⥫  ....","pCallMenu(oTb,aAr1)",TRUE},;
                {"....   権  㯯 㬥⮢ .......","pCallMenu(oTb,aArg)",TRUE},;
                {"      .ਧ . ⪨ ।.","pLessAll(2)",TRUE},;
                {"      㡫஢ ।  ।.","pDublPre()",TRUE},;        //  PRE
                {"       宦 (㡫஢) 㬥⮢-.","pSeekDouble()",FALSE},;    //  UNI
                {"         ᫮ ⥬ ᪠","pDeleteGrz()",TRUE},;      //  PRE
                {"      祭/몫.    ","pdStatusInv()",TRUE},;     //  UNI
                {"      ஢ઠ ࠢ쭮 㬥樨 㬥⮢","pVerifNumb()",FALSE},;     //  UNI
                {"      .窨   .䠪  ","pPrePrDoc()",FALSE},;      //  PRE
                {"aF3   .㭨ᠫ쭮 ।筮 㬥","pVirt(4)",FALSE},;         //  PRE
                {"      . / (易 . -)","pVirt(3)",FALSE},;         //  PRE
                {"      . .(易 -)","pVirt(2)",FALSE},;         //  PRE
                {"      ।. 㧮 ","pPreAlloc()",TRUE}}        //  PRE

    //  ⠭ 室 浪 樨 䠩.
    pInvOrder()
    SELE ARCWARES ORDE AW_CODMIN
    SELE WARES    ORDE W_CODMIN

    //  砫.     뢠 ᯮ⥫ ⠡  ⠭ 冷.
    LanUse(cdBase,"Pre_sell","PreMain,PreCode,PreDate",NO_ALIAS,SHAR_MODE,-1,NEW_SEL)
    LanUse(cdBase,"DetalPre","DetalPre",NO_ALIAS,SHAR_MODE,-1,NEW_SEL)
    SET RELA TO codMin INTO ASSORMIN
    LanUse(cDbase,"Price_cl","Price_cl",NO_ALIAS,SHAR_MODE,-1,NEW_SEL)

    SELE PRE_SELL ORDE nOrder REC nRecno
    DbSkip(-1)

    //  뢠  ᬮ ᯨ᪠.
    fSwopen(0,0,24,79,cColor,3)
    @ 0,47 SAY " ।⥫  ⮢ " COLOR cMainc
    @ 5,0 SAY Chr(195)+Repl(Chr(196),78)+Chr(180)
    @ 7,0 SAY Chr(195)+Repl(Chr(196),78)+Chr(180)
    oTB         := TBRowseDB(6,1,23,78)
    oTB:headSep := Chr(196)
    oTB:addColumn( TBColumnNew("⠇.| |६|||㬬.|.|६|.||||.||",{|| cDemoInv() }) )

    DO WHIL TRUE
        #include "table.ch"
        DO CASE
        CASE nKeys == K_INS;        IF lAddChInv( TRUE) THEN REF_INV    //  PRE
        CASE nKeys == K_TAB;        IF lAddChInv(FALSE) THEN REF_INV    //  PRE
        CASE nKeys == K_DEL;        IF lDeleteInv()     THEN REF_INV    //  PRE
        CASE nKeys == K_ENTER;      IF lInpPayNO()      THEN REF_INV    //  PRE
        CASE nKeys == K_F2;         pCallMenu(oTb,aArr)
        CASE nKeys == K_F4;         IF lChNumbPre()     THEN REF_INV    //  PRE
        CASE nKeys == K_F5;         pLoInPre();             REF_INV     //  PRE
        CASE nKeys == K_F6;         pPrintPre()                         //  PRE
        CASE nKeys == K_CTRL_F6;    pSpAccInv()                         //  UNI
        CASE nKeys == K_CTRL_F10;   pListPreWar(3)                      //  PRE
        CASE nKeys == K_F8;         pJumpInv();             REF_INV     //  UNI
        CASE nKeys == K_CTRL_LEFT;  pStatusInv();           REF_INV     //  UNI

        CASE nKeys == K_ALT_F2; pInfoText("।⥫  ⮢")
        CASE nKeys == K_ALT_F3;     pVirt(4)
        CASE nKeys == K_ALT_F5;     pNoGroupObj();          REF_INV
        CASE nKeys == K_ALT_F7;     pPrSwGrDoc()
        CASE nKeys == K_ALT_F8;     pGroupObj(oTb,TRUE);    REF_INV
        CASE nKeys == K_ALT_F9;     pLoInPre(1);            REF_INV
        CASE nKeys == K_ALT_F10;    pGroupObj(oTb,.F.);     REF_INV
        CASE nKeys == K_SH_F2;      pHelpTF("PRE")
        CASE nKeys == K_SH_F4;      pVirt(5)                            //  PRE
        CASE nKeys == K_SH_F5;      pVirt(6)                            //  PRE
        CASE nKeys == K_SH_F9;      pAddSarcis();           REF_INV
        CASE nKeys == K_SH_F10;     pLocateGr(oTb);         REF_INV

        CASE nKeys == K_ESC;    EXIT
        ENDC

        //  ࠦ 蠯 ।⥫쭮 
        pStab(oTb)

        IF lpCountWar
            SELE DETALPRE SEEK PRE_SELL->codInv
            COUNT TO nCount WHIL codInv==PRE_SELL->codInv

            SELE PRE_SELL
        ENDI
        @ 1,1 SAY "㬬: . "+cPict(sum,17)+" . "+cPict(sum*discount/100,16)+" %. "+Str(discount,12,7)+" . "+Str(nCount,4) COLO cMainc

        //    ࠦ ᪨ ਡ⮢  ࠬ஢ .
        @ 2,1 SAY " "+Left(cAdress_d(PRE_SELL->client,PRE_SELL->codAdr),72) COLO cOther

        CLIENT->  ( DbSeek(PRE_SELL->client) )
        @ 3,1 SAY ".: "+comm COLO cMainc
        @ 4,1 SAY ".:{"+client+"} "+CLIENT->name+" /"+cStr(sum*(1-discount/100)-sumPut,10,2) COLO cHelpc

        //   蠯 ࠦ ,  ᪫  ⥬ ⪨.
        @ 5,1 SAY "  -> "+CLIENT->comm   COLO cHelpc
        @5,52 SAY ">"+lab1
    ENDD
    SELE PRE_SELL
    nOrder      := zOrd()
    nRecno      := RecNo()

    //  뢠 ᯮ⥫ ⠡     㬮砭.
    PRE_SELL->( DbCloseArea() )
    DETALPRE->( DbCloseArea() )
    PRICE_CL->( DbCloseArea() )

    SELE ARCWARES   ORDE AW_CODWARES
    SELE WARES      ORDE W_CODWARES
    fDeact(cOldCol)

    pCloseJornal(sOp,1,"")
    pinStat(sOp,0)
    RETU

* ---------------------------------------------------------------------------
*   ࠦ ப ⠡   ᬮ ⠡筮 쥪.
*   ࠦ   筮 । .
STAT FUNC cDemoInv()
    LOCA nInv:=0, nQty:=0
    LOCA cStr:=Dtoc(dat)+" "+number+" "+Left(opTime,5)+" "+codInv+" "+IF(pay=="1","",IF(pay=="2",""," "))+" "+Str(sum*(1-discount/100),10,2)+" "
    cStr    += Left(Dtoc(datInv),5)+" "+Left(timInv,5)+" "+Left(Dtoc(endDat),5)+" "+IF(sch,"**","  ")+" "+IF(status,"*"," ")+" "+IF(dprov,"","  ")+" "+IF(dAlloc,"**","  ")+" "

    //   /筮/ 㤮⢮७ । .
    IF dAlloc
        SELE DETALPRE SEEK PRE_SELL->codInv
        SUM qtyAll, qty TO nInv, nQty WHIL codInv == PRE_SELL->codInv
        SELE PRE_SELL
    ENDI
    RETU cStr+IF(!dAlloc," ",IF(nQty<=0,"",IF(nQty<nInv-0.001,"","")))+" "+IF(dGr,"*"," ")

* ---------------------------------------------------------------------------
*      ᠭ ।⥫쭮 .
STAT FUNC lAddChInv( lMode )
    LOCA cOldCol:=SetColor(), cInv:="", nSum:=0, lNil:=TRUE, nPay:=1
    LOCA dDat       := IF(lMode, Date(), dat)
    LOCA cNumber    := IF(lMode, cAutoNumb("PRE_SELL",PR_CODINV), number)
    LOCA cOpTime    := IF(lMode, Time(), opTime)
    LOCA dDatInv    := IF(lMode, Date()+1,datInv)
    LOCA cTimInv    := IF(lMode, "08:00-20:00",timInv)
    LOCA dEndDat    := IF(lMode, Date()+1,endDat)
    LOCA cPay       := IF(lMode, "1",pay)
    LOCA nDiscount  := IF(lMode, 0.00, discount)
    LOCA nProv      := IF(lMode, IF(lpProvDoc,1,2), IF(dProv,1,2))
    LOCA nSch       := IF(lMode, 2, IF(sch, 1,2))
    LOCA coC:="", doD:=Date(), noS:=0, nSal:=2
    LOCA sOp    := IF(lMode,"0701","0702")
    S_FUNC

    cClient     := IF(lMode, Spac(4), client)
    cCodAdr     := IF(lMode, Spac(4), codAdr)
    csReas      := IF(lMode, Spac(72), comm)
    cInv        := IF(lMode, "", codInv)
    cSent3      := IF(lMode, Spac(25), lab1)

    IF !lMode   //   .  ⮢.
        IF Empty(codInv)
            ErrMess("!",cError); RETU FALSE
        ENDI
        IF status
            ErrMess("  饭!",cError); RETU FALSE
        ENDI
        IF dAlloc
            ErrMess(" ।  饭!",cError); RETU FALSE
        ENDI

        //    ୠ 権
        coC     := client
        doD     := dat
        noS     := sum
    ENDI

    //   ࠭  ⠥ 騥 ࠬ   ६.
    fSwopen(0,0,6,79,cOther,3)
    @ 1,1 SAY " :   ........  ............  ६ . ....."
    @ 2,1 SAY " 㯠⥫ ....  ⠢ ....  (1-,2-,3-/.) ."
    @ 3,1 SAY " ⠢ ⮢......... ६ ⠢ ...........   ........"
    @ 4,1 SAY ". (1-,2-) . ./ (1-,2-) .  業 (0-,1-,2..5-.) ."
    @ 5,1 SAY "%(+)/(-) .......... . ............... . ⪠ ...................."

    @1,33 GET dDat
    @1,48 GET cNumber   PICT "@K"
    @1,74 GET cOpTime   PICT "99:99"
    @2,16 GET cClient                       VALI Eval(bClient,cClient) .AND. Eval({||lCrPay(@nPay,cClient),cPay:=Str(nPay,1),TRUE})
    @2,36 GET cCodAdr                       VALI lStAdr(TRUE)
    @2,78 GET cPay                          VALI lValid({||cPay=="1".OR.cPay=="2".OR.cPay=="3"},"ୠ ଠ !")
    @3,19 GET dDatInv                       VALI lValid({||dDatInv>=dDat},"     !")
    @3,43 GET cTimInv   PICT "99:99-99:99"
    @3,71 GET dEndDat                       WHEN Eval({||dpOtsr(@dEndDat,dDatInv,C_INVOICES,cClient),TRUE});
                                            VALI lValid({||dEndDat>=dDatInv},"     㬥")
    @4,20 GET nProv     PICT "9"            VALI lValid({||nProv==1.OR.nProv==2},"ࠢ쭮 1  2!")
    @4,48 GET nSch      PICT "9"            VALI lValid({||nSch==1.OR.nSch==2},"ࠢ쭮 1  2!")
    @4,78 GET nSal      PICT "9"
    @5,15 GET nDiscount PICT "999.999999"   VALI lValid({||nDiscount<=100},"     100%")
    @5,31 GET csReas    PICT "@S15"
    @5,59 GET cSent3    PICT "@S20"
    READ
    IF LastKey()==K_ESC
        fDeact(cOldCol); RETU FALSE
    ENDI

    //  ᫨  ,  ନ㥬    .
    nSal    := IF(nSal>5,5,nSal)
    IF lMode THEN cInv := cGenCode(PR_CODINV,4,"codInv")
    IF( lMode, AddRec(-1), RecLock(-1) )

    REPL codInv WITH cInv, dat WITH dDat, number WITH cNumber, opTime WITH cOpTime, datInv WITH dDatInv, TimInv WITH cTimInv
    REPL endDat WITH dendDat, pay WITH cPay, client WITH cClient, discount WITH nDiscount
    REPL dProv WITH (nProv=1), sch WITH (nSch=1), codAdr WITH cAnalAdr(cCodAdr,cClient), comm WITH Upper(csReas), lab1 WITH cSent3
    UN_COMM

    //  ⠥  ⠫樥 , ⠬   .
    pCrDetSave(@nSum,nSal,sOp,lMode)

    //  ⥫쭠 ࠡ⪠ 蠯.  .
    SELE DETALPRE SEEK cInv
    lNil    := Eof()

    SELE PRE_SELL
    RecLock(-1)
    IF lNil             //   蠯 ᫨  客.
        DbDelete()
        DbSkip(-1)
    ELSE
        REPL sum WITH nSum
    ENDI
    UN_COMM
    fDeact( cOldCol )

    //    ୠ.   ०.
    IF lMode
        pAppJornal(sOp,1,"  "+cInv+"  "+Dtoc(dDat)+"  㬬 "+Str(nSum,12,2))
    ELSE
        pAppJornal(sOp,1,"  "+cInv+"  "+Dtoc(dDat)+"("+Dtoc(doD)+")  㬬 "+Str(nSum,12,2)+"("+Str(noS,12,2)+")")
    ENDI
    pinStat(sOp,0)
    RETU TRUE

* ---------------------------------------------------------------------------
*   ନ஢ ⠫樨 . ⠥  ࠢ筨 ⨬⮢
STAT PROC pCrDetSave(nSum,nSal,sOp,lMode)
    LOCA cOldCol:=SetColor(), oTb, nKeys:=0, nQ:=0
    LOCA cWar:="", cInv:=PRE_SELL->codInv

    //  뢠 ୠ   ⠫樨 .
    IF !lMode
        OP__JORN
    ENDI

    //  ⨢㥬 쥪 - ⠡  ᬮ ⠫樨 .
    SELE DETALPRE SEEK cInv
    DO WHIL !Eof() .AND. codInv == cInv
        nSum    += qtyAll*sales

        IF !lMode .AND. lDetInJorn  //   ன ⠫樨  ୠ.
            SELE JORNAL
            AddRec(-1)
            REPL codOper WITH sOp, tabel WITH cTabWorker, opDate WITH Date(), opTime WITH Time(), name WITH cpws(), stat WITH 1
            comm    := ""+cInv+" "+DETALPRE->codMin+" "+ASSORMIN->name+" "+Str(DETALPRE->sales*(1-PRE_SELL->discount/100),11,2)+" "+Str(DETALPRE->qtyAll,12,3)
        ENDI
        SELE DETALPRE SKIP
    ENDD
    IF !lMode
        CL__JORN
    ENDI
    SELE DETALPRE

    fSwopen(7,0,17,79,cOther,3)
    oTB         := TBrowseDB(2,1,16,78)
    oTB:headSep := ""

    // ᠭ 堭 ६饭  ⨢ ᫮ 䨫樨.
    oTB:goBottomBlock := { || LastGrid() }
    oTB:goTopBlock    := { || FirstGrid() }
    oTB:skipBlock     := { |x| FSkipFile(x) }
    SetGrid( cInv )

    // ᠭ  ⠡.
    oTB:addColumn( TBColumnNew("          ⨬              |     |⢮|",;
                                {||ASSORMIN->name+" "+codMin+" "+Str(sales,9,2)+" "+Str(qtyAll,10,3)+" "+stat}) )

    DO WHIL TRUE
        #include "table.ch"
        DO CASE
        CASE nKeys == K_INS;    IF lAddChDet(@nSum,nSal,TRUE)   THEN REF_INV
        CASE nKeys == K_TAB;    IF lAddChDet(@nSum,nSal,FALSE)  THEN REF_INV
        CASE nKeys == K_DEL
            IF lDelDet(@nSum)
                REF_INV
                oTb:Down()
            ENDI
        CASE nKeys == K_F5;     pLocaNam1();                    REF_INV
        CASE nKeys == K_ESC;    EXIT
        ENDC

        pStab(oTb)
        @ 1,1 SAY ".: "+reason+" 㬬:"+Str(qtyAll*sales,13,2)+"/"+Str(nSum,12,2) COLO cHelpc

    ENDD
    fDeact(cOldCol)
    RETU

* ---------------------------------------------------------------------------
*   /. / ப  䠩 ⠫樨.
STAT FUNC lAddChDet(nSum,nS,lMode)
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), nQty:=0, cStat:="", nSal:=0, cReas:=Spac(35), nDisc:=0
    IF !lMode .AND. Empty(codMin)
        ErrMess("!",cError); RETU FALSE
    ENDI

    cCodMin := IF(lMode,Spac(4),codMin)
    nQty    := IF(lMode,0,qtyAll)
    cStat   := IF(lMode," ",stat)
    nSal    := IF(lMode,0,sales)
    nDisc   := IF(lMode,0,discount)
    cReas   := IF(lMode,Spac(35),reason)

    //  ⠥  ६ 祭  .
    fSwopen(15,39,8,38,cColor,2)
    @ 1,1 SAY "                  : "
    @ 2,1 SAY " ⨬                 ...."
    @ 3,1 SAY "⢮         ............"
    @ 4,1 SAY " ⮢ (.) ..........."
    @ 5,1 SAY "(+)/業(-)  ⮢.  ......."
    @ 6,1 SAY "᭮ ..........................."
    @ 7,1 SAY "ਧ  ⮢                    ."

    @2,34 GET cCodMin WHEN lMode        VALI Eval(bCodMin,cCodMin)
    @3,26 GET nQty  PICT "99999999.999" VALI lValid({||nQty>=0},"祭 ⥫쭮!") .AND. IF(lMode,Eval({||nSal:=nSalCl(nS),TRUE}),TRUE)
    @4,27 GET nSal  PICT "99999999.99"  VALI lValid({||nSal>=0}," 稭 ⥫쭠!")
    @5,31 GET nDisc PICT "9999.99"
    @6,11 GET cReas PICT "@S27"
    @7,37 GET cStat
    READ
    fDeact( cOldCol )
    AF__INPUT

    //  ⥫  ⨬  祭.
    IF lMode
        DbSeek( PRE_SELL->codInv )
        LOCA FOR codMin==cCodMin WHIL codInv == PRE_SELL->codInv
        IF Found()
            DbGoTo( nRec )
            ErrMess(" !",cError)
            RETU FALSE
        ENDI
    ENDI

    //  뢠 樨    묨 (塞 ).
    IF !lMode THEN nSum -= sales*qtyAll

    //  ᨬ ଠ   .
    IF(lMode,AddRec(-1),RecLock(-1))
    REPL codInv WITH PRE_SELL->codInv, codMin WITH cCodMin, qtyAll WITH nQty, sales  WITH nSal, stat WITH cStat
    REPL discount WITH nDisc, reason WITH cReas
    nSum    += sales * qtyAll * (1-nDisc/100)
    UN_COMM
    RETU TRUE

* ---------------------------------------------------------------------------
*    業  ⨬  ࠩ 㯠⥫  砥  .
*   06.2007 ᯮ   .⮢஢.
STAT FUNC nSalCl(nS)
    LOCA nSal:=0, nSel:=Select()

    //   稨 ࠩ  業 ६  .
    CLIENT->( DbSeek(cClient) )
    IF !Empty(CLIENT->codPrice)
        PRICE_CL->( DbSeek(CLIENT->codPrice+cCodMin) )
        IF !Eof() THEN RETU PRICE_CL->endSal
    ENDI

    /*  饬 ᨬ 業 த ⨬  ᨬ
         ⪠ ⮢஢.   娢 .  */
    SELE WARES SEEK cCodMin
    DO WHIL !Eof() .AND. codMin == cCodMin
        nSal    := Max(nSal,IF(nS=0,d_begSal,;
                            IF(nS=1,d_begSal+deltaSal,;
                            IF(nS=2,endSal,;
                            IF(nS=3,endSal2,;
                            IF(nS=4,endSal3,endSal4))))))
        DbSkip()
    ENDD
    DbSelectArea(nSel)
    RETU nSal


* ---------------------------------------------------------------------------
*    ப  ⠫樨.
STAT FUNC lDelDet(nSum)
    IF Empty(codMin)
        ErrMess("!",cError); RETU FALSE
    ENDI
    IF !Fyn("  㤠 ப?",cError) THEN RETU FALSE

    nSum    -= sales * qtyAll * (1-discount/100)
    RecLock(-1)
    DbDelete()
    DbSkip( -1 )
    RETU TRUE

* ---------------------------------------------------------------------------
*    .  ࠭祭   ஬ ࠢ.
STAT FUNC lDeleteInv()
    LOCA cOldCol:=SetColor(), cInv:=codInv, sOp:="0703"
    S_FUNC
    IF !Fyn("  㤠 ?",cError) THEN RETU FALSE

    ftxt_act("   㭤....",cHelpc)
    pAppJornal(sOp,1," "+PRE_SELL->codInv+"  "+client+" "+cNameCl(client)+"  "+Dtoc(dat)+"  㬬 "+Str(Sum,12,2))

    //    ⠫  .
    IF lDetInJorn
        OP__JORN
        SELE DETALPRE SEEK cInv
        DO WHIL !Eof() .AND. codInv == cInv
            SELE JORNAL
            AddRec(-1)
            REPL codOper WITH sOp, tabel WITH cTabWorker, opDate WITH Date(), opTime WITH Time(), name WITH cpws(), stat WITH 1
            comm    := ""+cInv+" "+DETALPRE->codMin+" "+ASSORMIN->name+" "+Str(DETALPRE->sales*(1-PRE_SELL->discount/100),11,2)+" "+Str(DETALPRE->qtyAll,12,3)
            SELE DETALPRE SKIP
        ENDD
        CL__JORN
    ENDI

    lBlockGroup({"PRE_SELL","DETALPRE"})
    SELE DETALPRE SEEK PRE_SELL->codInv
    DELE WHIL codInv == PRE_SELL->codInv
    SELE PRE_SELL
    DbDelete()
    DbSkip(-1)
    UNLOCK_COMMIT
    fDeact( cOldCol )
    RETU TRUE

* ---------------------------------------------------------------------------
*   ।.   㧮筮  ( 筮). -
*   ⥫쭮 訢 ਡ .
*    ᭮ ᮧ     ६ ⠢ ⮢஢.
*   03.2007   ⠭ ࠭⥫  㧪
*   06.2007 ᯮ짮   ࠢ筨 ⮢஢.
*   11.2008  稨 ⨯ 業 ,   業   䠪
*   12.2009  稨 ࠩ   - 業   ࠩ .  
*   03.2011  ᪫ १  㤥 㦠 ⮢ -   
*   09.2012   ᮧ /  । 
*   10.2012  冷 ᮢ... ⨬ + ࠡ⪠ 㬮砭
*   08.2014    । ⥪⮬ ᭮, ..  䠪  ࠧ ⮢
PROC pPreAlloc()
    LOCA cOldCol:=SetColor()
    LOCA dDat:=Date(), cNumber:=cAutoNumb("INVOICES",I_CODINV), ntSal:=2
    LOCA dEndDat:=Date()+(endDat-datInv), nTipReal:=IF(lInventor,2,1), nSch:=2
    LOCA aArr:={}, nMax:=0, nQty:=0, nQ:=0, nTip:=0, nSal:=0, cNumb:=Spac(12)
    LOCA nStores:=STORES->(zOrd()), lBreak:=FALSE, nL:=0, nJ:=0
    LOCA nSum:=0, nTax:=0, nI:=0, c:="", lPrice:=TRUE
    LOCA cInv:=codInv, cCodInv:="", nCr:=0, nCredit:=0, nDetal:=0
    LOCA cCl:="", cCl1:=""
    LOCA sOp:="0712"
    S_PROC

    cTabel      := cTabStock                //   ⨫
    cClient     := cClient1 := client       //  㯠⥫ ࠢ 㧮⥫
    cCodStores  := Left(cSourSin+Spac(2),2) //   ᪫
    csReas      := Left(comm,70)            //  IF(sch,"","  ")+Left(comm,70)
    cSent3      := Spac(25)

    //   ⮢ .
    IF Empty(codInv)
        ErrMess("!",cError); RETU
    ENDI
    IF status
        ErrMess("襭 ४஬   㬥!",cError); RETU
    ENDI
    IF dAlloc
        ErrMess("饭 ।,    ਧ .",cError); RETU
    ENDI

    //    ⠬  㧮 .
    IF !lBlockOtgr(@nCr,@nCredit,TRUE)  //  饭, ᫨  믨᪨ ॢ襭 ।
        ErrMess("  ᫮ 㧮 !",cError); RETU
    ENDI
    IF !(pay=="1".OR.pay=="2") .AND. !lStat_emp("6225",FALSE)
        ErrMess("  ᯫ!",cError); RETU
    ENDI

    /*     ।  ⮬ 㬬 । 㧪. 
        ⠭ nCr - ⮢  ; nCredit - 㬬 ।  */
    IF lgCredit             //   ஫  ।
        IF nCredit > 0      //    㥬 ।

            //   ।    ⮬ ।񭭮 
            SELE DETALPRE SEEK PRE_SELL->codInv
            DO WHIL !Eof() .AND. codInv == PRE_SELL->codInv
                nDetal  += (qtyAll - qty)*sales*(1-discount/100)*(1-PRE_SELL->discount*100)
                DbSkip()
            ENDD
            SELE PRE_SELL

            IF nCr+nDetal > nCredit
                ErrMess("㬬  "+Alltrim(Str(nCr,15,2))+"  㬬 । 㧪 "+AllTrim(Str(nDetal,15,2))+"  㬬 । "+AllTrim(Str(nCredit,15,2))+"  ",cError)
                RETU
            ENDI
        ENDI
    ENDI

    //   ࠭  ⠥ 騥 ࠬ   ६.
    fSwopen(0,0,6,79,cOther,4)
    @ 1, 1 SAY "   :     ..  ........  ............"
    @ 2, 1 SAY " 窨  ........  1-  䠪 ( ன)   ."
    @ 3, 1 SAY "᭮  (F3) ..........................................................."
    @ 4, 1 SAY "⥬  㧮筮  (F3)           ........................."
    @ 5, 1 SAY "1-業 ।  ⨯ 業    .    騪 (F3) ...."

    @ 1,44 GET cCodStores           VALI Eval(bCodStores,cCodStores)
    @ 1,52 GET dDat                 VALI NO_BEFDAT(dDat)
    @ 1,67 GET cNumber  PICT "@K"
    @ 2,23 GET dEndDat              WHEN Eval({||dpOtsr(@dEndDat,dDat,C_INVOICES,client),TRUE});
                                    VALI lValid({||dEndDat>=dDat},"     㬥")
    @ 2,78 GET nSch     PICT "9"
    @ 3,20 GET csReas   PICT "@S59"
    @ 4,54 GET cSent3   PICT "@S25"
    @ 5,51 GET ntSal    PICT "9"
    @ 5,75 GET cTabel               VALI Eval(bTabel,cTabel)
    READ
    fDeact( cOldCol )
    AP__INPUT

    /*    室    ⮢ । ।塞
        -. ࠭⥫   ⮬ ⮢୮ ⪠  ᪫.   */

    ftxt_act("    ⮬⨧஢ ᮧ ... ",cHelpc)
    cSourSin    := cCodStores   //   ᪫ ।  쭥襥

    //  ⮬᪮ ᮧ 㧪.
    lBlockGroup({"STORES","HISTORY","INVOICES","DETALINV","DETALPRE","PRE_SELL"})

    SELE INVOICES   //    
    cCodInv     := cGenCode(I_CODINV,4,"codInv")

    //  । ⨯ 業 㯠⥫
    SELE CLIENT SEEK PRE_SELL->client
    nTip        := tip

    //   ᪫ । ⪨ ⮢஢.
    SELE STORES ORDE ST_CODSTORES_CODWARES
    SELE DETALPRE SEEK cInv
    DO WHIL !Eof() .AND. codInv==cInv
        X_DEMO

        //   ⠫   ⨬ .
        nQty    := qtyAll

        SELE WARES SEEK DETALPRE->codMin
        DO WHIL !Eof() .AND. codMin == DETALPRE->codMin

            //   ⮩   ।.
            IF nQty <= 0
                DbSkip(); LOOP
            ENDI

            //    筮 ⪠ ᪫.
            SELE STORES SEEK cCodStores+WARES->codWares
            IF Eof() .OR. qtyAll <= 0
                SELE WARES SKIP
                LOOP
            ENDI

            //   ⪠  ᪫  ⮢. nQty - 室 ⢮.
            IF qtyAll < nQty        //  室    㣮 窨 ⮢.
                nQ      := qtyAll
                nQty    -= qtyAll
            ELSE                    //  ⮪  ४뢠 ॡ.
                nQ      := nQty
                nQty    := 0
            ENDI

            //   ⪨  ᪫.
            qtyAll      -= nQ

            //  । 業    ⨯ 業 
            nSal        := DETALPRE->sales*(1-PRE_SELL->discount/100)
            IF ntSal == 1 .AND. nTip <> 0
                SELE WARES
                nSal    := IF(nTip == 1, endSal,;
                           IF(nTip == 2, endSal2,;
                           IF(nTip == 3, endSal3,;
                           IF(nTip == 4, endSal4,;
                           IF(nTip == 5, endSal5,;
                           IF(nTip == 6, endSal6,;
                           IF(nTip == 7, endSal7,;
                           IF(nTip == 8, endSal8,endSal9))))))))
            ENDI

            //   稨 ࠩ  ⪮ 㪠 業   ᯥࠩ.
            lPrice  := FALSE
            CLIENT->( DbSeek(PRE_SELL->client) )
            IF ntSal == 1 .AND. !Empty(CLIENT->codPrice)
                SELE PRICE_CL SEEK CLIENT->codPrice + DETALPRE->codMin
                IF !Eof()
                    nSal    := endSal
                    lPrice  := TRUE
                ENDI
            ENDI

            //   ⠫    ⨬  ⮢.
            SELE HISTORY APPE       //  .
            REPL codWares WITH STORES->codWares, codStores WITH cCodStores, dat WITH dDat
            REPL qtyAll WITH nQ, sales WITH nSal, sum WITH nQ*nSal
            REPL codOper WITH O_WITH_STOCK, codDoc WITH cCodInv, client WITH PRE_SELL->client, tipDoc WITH D_INV
            REPL tax_n WITH WARES->pnds, tax_s WITH WARES->tax_s

            SELE DETALINV APPE      //  ⠫
            REPL codInv WITH cCodInv, codWares WITH STORES->codWares, qtyAll WITH nQ, stat WITH DETALPRE->stat
            REPL sales WITH IF(ntSal == 1 .AND. (nTip <> 0 .OR. lPrice),nSal,DETALPRE->sales), tax_n WITH WARES->pnds, tax_s WITH WARES->tax_s

            //   㬬      ⠫樨 .
            nSum    += IF(ntSal == 1 .AND. (nTip <> 0 .OR. lPrice),nQ*nSal,qtyAll*sales)
            nTax    += SUMMNSP(IF(ntSal == 1 .AND. (nTip <> 0 .OR. lPrice),nQ*nSal,qtyAll*sales),DETALINV->tax_s)

            SELE DETALPRE           //  ⠫ 
            qty     += nQ

            //   ᪠ ࠢ筨 ⮢஢.
            SELE WARES SKIP
        ENDD

        //   ᪠ ⠫ 
        SELE DETALPRE SKIP
    ENDD

    //  ଫ 蠯 㧮筮 .
    SELE INVOICES APPE
    REPL codInv WITH cCodInv, codStores WITH cCodStores, dat WITH dDat
    REPL endDat WITH dEndDat, number WITH cfNumb(cNumber,PRE_SELL->dProv), pay WITH PRE_SELL->pay, client WITH PRE_SELL->client
    REPL dProv WITH PRE_SELL->dProv, tabel WITH cTabel, keeping WITH TRUE
    REPL sum WITH nSum, tax_s WITH nTax, dDisc WITH TRUE, discount WITH IF(ntSal==1,0,PRE_SELL->discount)
    REPL tipReal WITH ntipReal, reason WITH csReas, codAdr WITH cAnalAdr(PRE_SELL->codAdr,PRE_SELL->client)
    REPL client_out WITH "", tabel3 WITH cTabWorker, lab1 WITH cSent3
    REPL ordDat WITH PRE_SELL->dat, ordTim WITH PRE_SELL->opTime, ordPrim WITH " "

    //  ய뢠 ਧ ࠡ⪨ 
    SELE PRE_SELL
    dAlloc  := TRUE
    STORES->( zSet(nStores) )
    UNLOCK_COMMIT

    //    䠪  ᮧ .  ,   ன, -  㬮砭.  祣  
    IF nSch = 1
        cNumb   := cAutoNumb("SCHFAOUT",0)

        //  ।   "室饩"  ( 㦥  )
        IF lpSchEqInv THEN cNumb := INVOICES->number

        cCl     := Spac(4)              //  㧮ࠢ⥫
        cCl1    := INVOICES->client     //  㧮⥫

        //  ନ㥬   ᮮ⢥騩   ⠢塞 ਧ.
        lBlockGroup({"INVOICES","SCHFAOUT"},-1,FALSE)

        SELE SCHFAOUT APPE
        REPL codSch WITH INVOICES->codInv, dat WITH INVOICES->dat, number WITH cNumb
        REPL client_out WITH cCl, client_in WITH cCl1

        INVOICES->sch   := TRUE
        UNLOCK_COMMIT

        pAppJornal(sOp,1," । ᤥ /   "+INVOICES->codInv+"  "+Dtoc(INVOICES->dat)+"  "+cCl+" "+cNameCl(cCl))
    ENDI

    SELE PRE_SELL
    fDeact(cOldCol)
    pAppJornal(sOp,1," "+cInv+"  "+client+" "+cNameCl(client)+"  "+Dtoc(dat)+"   "+cCodInv+"  㬬 "+Str(nSum,12,2)+IF(nSch=1,"   䠪",""))
    pinStat(sOp,0)
    RETU

* ---------------------------------------------------------------------------
*   室 ⮢  ।. . ᮪ 㤮⢮७⥩.
*   03.2007   ᭮ .
PROC pListPreWar(nReestr)
    LOCA cOldCol:=SetColor(), nOrd:=zOrd(), nRec:=RecNo()
    LOCA dBeg:=Date(), dEnd:=Date(), cCont:=Spac(15), cKta:=Spac(12), cLab:=Spac(10)
    LOCA nStr:=99999, nPp:=0, nPage:=0, nRep:=110, nRest:=2, nR:=0
    LOCA nI:=0, cTxt:="", cDbf:="", cNtx:="", cWar:="", cCl:="", cGr:="", cN:=""
    LOCA sOp:=Token("0733,0734,0735",",",nReestr)
    LOCA aStr:={{"codMin",      "C",    4,  0},;
                {"name",        "C",    50, 0},;
                {"qtyAll",      "N",    12, 3},;
                {"qty",         "N",    12, 3}}
    S_PROC

    //  ᯮ 楤  맮 ᪮ 
    IF nReestr = 2      //   ।⥫ 
        pReestrPre(); RETU
    ENDI
    IF nReestr = 3      //   ⮢. ᯮ ࠯
        pReestrAg(); RETU
    ENDI

    cClient     := Spac(4)
    cCodGroup   := Spac(2)
    csReas      := Spac(35)

    //  ⠥ ࠬ   
    fSwopen(19,4,4,73,cColor,2)
    @ 1,1 SAY "   砫 ........   ........ ਮ ६"
    @ 2,1 SAY " 㯠⥫  祣 (F3) ....  㪢   ..............."
    @ 3,1 SAY "㪢늒 ............  .......... ᭮(F3) .........................."

    @ 1,32 GET dBeg
    @ 1,49 GET dEnd         VALI lValid({||dBeg<=dEnd}," 砫쭮 !")
    @ 2,32 GET cClient      VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
    @ 2,58 GET cCont
    @ 3,10 GET cKta
    @ 3,26 GET cLab
    @ 3,47 GET csReas       PICT "@S26"
    READ
    fDeact(cOldCol)
    AP__INPUT

    //  ஥ ࠡ祣 䠩  ᯨ᪠ .
    cCont   := Upper(Alltrim(cCont))
    cKta    := Upper(Alltrim(cKta))
    cLab    := Upper(Alltrim(cLab))
    csReas  := Upper(Alltrim(csReas))
    ftxt_act("    ! ନ ..",cHelpc,TRUE)

    cTxt    := zTemp(cdTemp,"TXT",32)
    cDbf    := zTemp(cdTemp,"DBF",32)
    cNtx    := zTemp(cdTemp,"NTX",32)

    DbCreate(cDbf,aStr)
    LanUse("",cDbf,NO_INDEX,"TEMP",EXCL_MODE,-1,NEW_SEL)
    INDE ON codMin  TO (cNtx)

    SELE PRE_SELL ORDE PR_DAT_NUMBER
    DbGoTop()
    DO WHIL !Eof() .AND. dat <= dEnd
        BR_REPORT
        X_DEMO

        //  ᥢ  砫쭮 
        IF dat < dBeg
            DbSkip(); LOOP
        ENDI

        //  ᥢ  ⥬ ⪥ 
        IF !Empty(cLab) .AND. At(cLab,Upper(lab1))<=0
            DbSkip(); LOOP
        ENDI

        //  ᥢ  ᭮ 
        IF !Empty(csReas) .AND. At(csReas,Upper(comm))<=0
            DbSkip(); LOOP
        ENDI

        //  ᥢ  ࠬ .
        IF !Empty(cClient) .AND. cClient <> client
            DbSkip(); LOOP
        ENDI

        CLIENT->( DbSeek(PRE_SELL->client) )
        IF !Empty(cCont) .AND. At(cCont,Upper(CLIENT->name))<1
            DbSkip(); LOOP
        ENDI
        IF !Empty(cKta) .AND. At(cKta,Upper(CLIENT->comm))<1
            DbSkip(); LOOP
        ENDI

        //  ஢ ⠫樨    ६ﭪ.
        SELE DETALPRE SEEK PRE_SELL->codInv
        DO WHIL !Eof() .AND. codInv == PRE_SELL->codInv
            IF qty >= qtyAll
                DbSkip(); LOOP
            ENDI

            SELE TEMP SEEK DETALPRE->codMin
            IF Eof()
                ASSORMIN->( DbSeek(DETALPRE->codMin) )
                DbAppend()
                REPL codMin WITH DETALPRE->codMin, name WITH ASSORMIN->name
            ENDI
            qtyAll  += DETALPRE->qtyAll
            qty     += DETALPRE->qty

            SELE DETALPRE SKIP
        ENDD

        SELE PRE_SELL SKIP
    ENDD
    zSet(nOrd)
    DbGoTo(nRec)

    //  뢮  ⥪⮢ 䠩 ᪠ .
    IF nRepp <> K_ESC
        SELE TEMP
        INDE ON name TO (cNtx)
        DbGoTop()

        O____A
        DO WHIL !Eof()
            X_DEMO

            IF nStr > nLenSt
                IF nPage > 0    THEN Qout( Chr(12) )
                ? Padc("᮪ 㤮⢮७⥩  ",nRep-7)+"."+Str(++nPage,3)
                ? Repl("-",nRep)
                ? "                  ⨬         |  믨ᠭ  |  饭  |  㯨  |   ਬ砭"
                ? Repl("-",nRep)
                nStr    := 3
            ENDI

            ? name+" "+codMin+" "+cStr(qtyAll,12,3)+" "+cStr(qty,12,3)+" "+cStr(qtyAll-qty,12,3)
            ++nStr
            DbSkip()
        ENDD
        ? Chr(12)
        C____A
    ENDI

    //  ⠭ ﭨ । ணࠬ.
    fDeact( cOldCol )
    IF nRepp <> K_ESC THEN pFileOutDevice( cTxt,132,6 )

    TEMP->( DbCloseArea() )
    Ferase( cTxt )
    Ferase( cDbF )
    Ferase( cNtx )
    SELE PRE_SELL
    pinStat(sOp,0)
    RETU

* ---------------------------------------------------------------------------
*    ।⥫ .  ६饭 ⮢.
*   1309    ࠭祭    ⠢... - ?
STAT PROC pReestrAg()
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), nOrd:=zOrd()
    LOCA lLoca:=FALSE, cInv:="", nS:=0, cCl:="", cpa:=""
    LOCA nPage:=0, nStr:=999999, nI:=0, nRep:=130, nPp:=0
    LOCA dBeg:=Ctod(""), dEnd:=Date(), cReas:=Spac(20), cCont:=Spac(10)
    LOCA cKta:=Spac(12), nSum:=0, cLab:=Spac(10), nAll:=3, cAdr:=Spac(30)
    LOCA cTxt:="", cDbf:="", cNtx:="", sOp:="0735"
    LOCA aStr:={{"codInv",      "C",    4,  0},;
                {"comm",        "C",    12, 0},;
                {"dat",         "D",    8,  0},;
                {"opTime",      "C",    8,  0},;
                {"client",      "C",    4,  0},;
                {"name",        "C",    50, 0},;
                {"adress",      "C",    100,0},;
                {"qty",         "N",    10, 0},;
                {"sum",         "N",    12, 2}}

    //  ⠥ ࠬ   
    fsWopen(18,1,5,76,cOther,2)
    @ 1,1 SAY " ।:           ਮ ।  ........  ........"
    @ 2,1 SAY "㪢   ..........  ............  ᭮ ...................."
    @ 3,1 SAY "㪢   .......... ।  1-।., 2-, 3- ."
    @ 4,1 SAY "   ⠢                    .............................."
    @1,55 GET dBeg
    @1,67 GET dEnd                      VALI lValid({||dBeg<=dEnd}," 砫쭮!")
    @2,16 GET cCont
    @2,31 GET cKta
    @2,55 GET cReas
    @3,13 GET cLab
    @3,74 GET nAll  PICT "9"
    @4,45 GET cAdr
    READ
    fDeact( cOldCol )
    AP__INPUT

    //   뢮 १  ஬ 䠩  ⥪⮢ 䠩, 뢠 ஬ ⮣.
    cReas   := Upper(AllTrim(cReas))
    cCont   := Upper(Alltrim(cCont))
    cKta    := Upper(Alltrim(cKta))
    cLab    := Upper(Alltrim(cLab))
    cAdr    := Upper(Alltrim(cAdr))

    //  ஥ ࠡ祣 䠩  ᯨ᪠ .
    ftxt_act("    ! ନ ..",cHelpc,TRUE)

    cTxt    := zTemp(cdTemp,"TXT",32)
    cDbf    := zTemp(cdTemp,"DBF",32)
    cNtx    := zTemp(cdTemp,"NTX",32)

    DbCreate(cDbf,aStr)
    LanUse("",cDbf,NO_INDEX,"TEMP",EXCL_MODE,-1,NEW_SEL)
    INDE ON Upper(comm)+Dtos(dat)+opTime  TO (cNtx)

    SELE PRE_SELL ORDE PR_DAT_NUMBER
    DbGoTop()
    DO WHIL !Eof() .AND. dat <= dEnd
        BR_REPORT
        X_DEMO

        //  ᥢ  砫쭮 
        IF dat < dBeg
            DbSkip(); LOOP
        ENDI

        //  ᥢ  ⥬ ⪥ 
        IF !Empty(cLab) .AND. At(cLab,Upper(lab1))<=0
            DbSkip(); LOOP
        ENDI

        //  ᥢ  ᭮ 
        IF !Empty(cReas) .AND. At(cReas,Upper(comm))<=0
            DbSkip(); LOOP
        ENDI

        //  ࠬ ⮢
        CLIENT->( DbSeek(PRE_SELL->client) )
        IF !Empty(cCont) .AND. At(cCont,Upper(CLIENT->name))<1
            DbSkip(); LOOP
        ENDI

        IF !Empty(cKta) .AND. At(cKta,Upper(CLIENT->comm))<1
            DbSkip(); LOOP
        ENDI

        //  ।  ᮬ ...  ᫨ 㦭 - ᥢ
        IF Empty(PRE_SELL->codAdr)
            cpa                 := CLIENT->adress
        ELSE
            SELE ADRESS_D SEEK PRE_SELL->client+PRE_SELL->codAdr
            IF !Eof()
                cpa             := ADRESS_D->adress
            ELSE
                cpa             := CLIENT->adress
            ENDI
        ENDI

        SELE PRE_SELL
        IF !Empty(cAdr) .AND. At(cAdr,Upper(cpa))<1
            DbSkip(); LOOP
        ENDI

        //     ᮧ   ६ﭪ.
        SELE TEMP APPE
        REPL codInv WITH PRE_SELL->codInv, comm WITH CLIENT->comm, dat WITH PRE_SELL->dat, opTime WITH PRE_SELL->opTime
        REPL client WITH PRE_SELL->client, name WITH CLIENT->name, sum WITH PRE_SELL->sum, TEMP->adress WITH cpa

        //  । ᫮ 権  
        SELE DETALPRE SEEK PRE_SELL->codInv
        COUNT TO nSum WHIL codInv == PRE_SELL->codInv
        TEMP->qty               := nSum

        SELE PRE_SELL SKIP
    ENDD

    //       ⠡ .
    zSet(nOrd)
    DbGoTo(nRec)

    //  뢮  ⥪⮢ 䠩 ᪠ .
    IF nRepp <> K_ESC
        SELE TEMP TOP
        nSum    := 0
        O____A
        DO WHIL !Eof()
            X_DEMO

            IF nStr > nLenSt
                IF nPage > 0    THEN Qout( Chr(12) )
                ? Padc("  -  ⮢  ਮ  "+Dtoc(dBeg)+"  "+Dtoc(dEnd),nRep-7)+"."+Str(++nPage,3)
                ? Repl("-",nRep)
                ? ". |⠇|६|          㯠⥫        |          ⠢ - ࣮ 窨      ||㬬 .|"
                ? Repl("-",nRep)
                nStr    := 3
            ENDI

            ? Left(comm,10)+" "+Left(Dtoc(dat),5)+" "+Left(opTime,5)+" "+Left(name,40)+" "+Left(adress,46)+" "+Str(qty,3)+" "+cStr(sum,10,2)+" "+codInv
            nSum    += sum
            ++nStr
            DbSkip()
        ENDD
        ? Repl("-",nRep)
        ? "⮣"+Spac(105)+cStr(nSum,15,2)+CRLF+Chr(12)
        C____A
    ENDI

    //  ⠭ ﭨ । ணࠬ.
    fDeact( cOldCol )
    IF nRepp <> K_ESC THEN pFileOutDevice( cTxt,132,6 )

    TEMP->( DbCloseArea() )
    Ferase( cTxt )
    Ferase( cDbF )
    Ferase( cNtx )
    SELE PRE_SELL
    pinStat(sOp,0)
    RETU


* ---------------------------------------------------------------------------
*    ।⥫쭮  ࣮ .  ଥ .
STAT PROC pPrintPre()
    LOCA cOldCol:=SetColor(), nSum:=0
    LOCA nStr:=0, nI:=0, cTxt:=zTemp(cdTemp,"TXT",32), nRec:=RecNo(), nB:=1, npp:=0
    LOCA cStr:="", nPage:=1, cInv:=codInv, cWar:=""
    LOCA cDbf:=zTemp(cdTemp,"DBF",32), cNtx:=zTemp(cdTemp,"NTX",32)
    LOCA aStr:={{"codMin",      "C",    4,  0},;
                {"name",        "C",    50, 0},;
                {"qtyAll",      "N",    12, 3},;
                {"qty",         "N",    12, 3},;
                {"sales",       "N",    11, 2},;
                {"discount",    "N",    12, 6},;
                {"reason",      "C",    72, 0},;
                {"stat",        "C",    1,  0}}
    ftxt_act("   㭤...",cHelpc)

    //   ६ﭪ.
    DbCreate(cDbf,aStr)
    LanUse("",cDbf,NO_INDEX,"TEMP",EXCL_MODE,-1,NEW_SEL)
    INDE ON name+codMin  TO (cNtx)

    //  ७ ⠫  ६ﭪ.
    SELE DETALPRE SEEK cInv
    DO WHIL !Eof() .AND. codInv == cInv
        X_DEMO

        //  裡 / ⠡栬 ⠭.
        TEMP->( DbAppend() )
        TEMP->codMin    := codMin
        TEMP->name      := ASSORMIN->name
        TEMP->qtyAll    := qtyAll
        TEMP->qty       := qty
        TEMP->sales     := sales
        TEMP->discount  := discount
        TEMP->stat      := stat
        TEMP->reason    := reason

        DbSkip()
    ENDD

    O____A              //  뢮   ⥪⮢ 䠩.
    SELE PRE_SELL
    nSum    := 0

    //  뢮 让  
    ? "{"+cInv+"} "+Left(cpName,50)+"  N_"+number+"  "+Dtoc(dat)+"/"+opTime+Spac(44)+_ZDT

    CLIENT->( DbSeek(PRE_SELL->client) )
    ? "㯠⥫ {"+client+"} "+CLIENT->name+" ⠢ "+Dtoc(datInv)+" ६ "+timInv+"  "+IF(pay=="1","",IF(pay=="2","/","---"))+" / "+IF(sch," ","")
    ? " "+CLIENT->comm+" ᭮ "+comm
    ? " "+Left(cAdress_d(PRE_SELL->client,PRE_SELL->codAdr),121)

    SELE TEMP ORDE IF(lSortName,1,DB_NIL)
    DO WHIL !Eof()
        X_DEMO
        IF nStr == 0
            IF nPage > 1
                ? ""
                ? Chr(12)
                ? "த  {"+cInv+"} N_ "+PRE_SELL->number+"  "+Dtoc(PRE_SELL->dat)+Spac(77)+"."+Str(nPage,3)
            ENDI
            ++nPage
            ? "Ŀ"
            ? "/           ⨬             ⢮।.      /泑㬬ਬ砭"
            ? "Ĵ"
            nStr    := IF(nPage > 1,3,7)
        ENDI

        //  ࠦ ࠡ ப 㬥.
        ? Str(++npp,4)+" "+name+" "+codMin+" "+Str(qtyAll,10,3)+" "+Str(qty,10,3)+" "+Str(sales,10,2)+" "+Str(discount,9,3)+"% "+Str(qtyAll*sales*(1-discount/100),11,2)+" "+Left(reason,10)+" "+stat
        IF !ldLine THEN ? ""
        nStr    := IF(nStr <= nLenSt, nStr+IF(ldLine,1,2), 0 )
        nSum    += qtyAll*sales*(1-discount/100)
        DbSkip()
    ENDD
    SELE PRE_SELL
    ? ""
    ? "㬬 "+cPict(nSum,18)+"  "+Str(discount,10,5)+"% 㬬  ᥬ ᪨"+cPict(nSum*(1-discount/100),18)
    ? Chr(12)
    C____A
    fDeact(cOldCol)

    pFileOutDevice( cTxt, 132, 6 )
    TEMP->( DbCloseArea() )
    Ferase( cTxt )
    Ferase( cDbf )
    Ferase( cNtx )
    RETU

* ---------------------------------------------------------------------------
*  ਧ ।  ⥪饣 . ୮ ।
*   11.2006    ⪨ ⨪ 믮 -  ᪫
PROC pLessAll(n)
    IF !dAlloc
        ErrMess("  ।!",cError); RETU
    ENDI

    IF Fyn("   ਧ ।?",cError)
        IF n == 1   //   ⪠
            SELE DETALPRE SEEK PRE_SELL->codInv
            FilLock( -1 )
            REPL qty WITH 0 WHIL codInv == PRE_SELL->codInv
            UN_COMM
        ENDI

        SELE PRE_SELL
        RecLock(-1)
        dAlloc  := FALSE
        UN_COMM
    ENDI
    RETU

* ---------------------------------------------------------------------------
*   ᫥⥫    ᫮ ᫮
*   02.2009 . ⡮  㯯  ᫮ ᪠
*   07.2013 . ࠭⥫  , 室騬   㬥
PROC pLoInPre(nGr)
    STAT dBeg, dEnd, nBeg, nEnd, cReas, cCont, nAll, cKta, cLab, cNumb
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), lLoca:=FALSE, cInv:="", nS:=0, cCl:=""
    DEFAULT dBeg TO Ctod(""), dEnd TO Date(), nBeg TO 0, nEnd TO 999999999.99, cReas TO ""
    DEFAULT cCont TO "", nAll TO 3, cKta TO "", cLab TO "", nGr TO 0, cNumb TO ""
    cReas   := Left(cReas+Spac(20),20)
    cCont   := Left(cCont+Spac(10),10)
    cKta    := Left(cKta+Spac(12),12)
    cLab    := Left(cLab+Spac(10),10)
    cNumb   := Left(cNumb+Spac(8),8)

    //  ⠥ ࠬ ᪠  
    fsWopen(18,1,5,76,cOther,2)
    @ 1,1 SAY " ।:   ........   ........  ........"
    @ 2,1 SAY "ࢠ 㬬  ............  ............     祣 ...."
    @ 3,1 SAY "㪢   ..........  ............  ᭮ ...................."
    @ 4,1 SAY "1-,2-,3- . 㪢  .......... . .  㯯(F3) ...."
    @1,37 GET cNumb
    @1,55 GET dBeg
    @1,67 GET dEnd                      VALI lValid({||dBeg<=dEnd}," 砫쭮!")
    @2,18 GET nBeg  PICT "999999999.99" VALI lValid({||nBeg>=0},"⥫쭠 㬬!")
    @2,34 GET nEnd  PICT "999999999.99" VALI lValid({||nEnd>=nBeg}," ⮢!")
    @2,71 GET cClient                   VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
    @3,16 GET cCont
    @3,31 GET cKta
    @3,55 GET cReas
    @4,20 GET nAll  PICT "9"
    @4,31 GET cLab
    @4,71 GET cCodMin                   VALI IF(Empty(cCodMin),TRUE,Eval(bCodMin,cCodMin))
    READ
    fDeact( cOldCol )
    AP__INPUT

    cReas   := AllTrim(cReas)
    cCont   := Alltrim(cCont)
    cKta    := Alltrim(cKta)
    cLab    := Alltrim(cLab)
    cNumb   := Alltrim(Upper(cNumb))

    IF Empty(nGr)       //   㬥.
        fTxt_act("...",cHelpc)
        DbSkip()

        //    .
        DO WHIL !Eof()
            lLoca   := TRUE

            //   믨᪨
            IF dBeg > dat .OR. dEnd < dat
                DbSkip();  LOOP
            ENDI

            //  ।.
            IF nAll == 1 .AND. !dAlloc
                DbSkip(); LOOP
            ENDI
            IF nAll == 2 .AND. dAlloc
                DbSkip(); LOOP
            ENDI

            //    㬬 㬥.
            nS          := Round(sum,2)
            IF nBeg > nS .OR. nEnd < nS
                DbSkip();  LOOP
            ENDI

            //  . 㪢   .
            IF !Empty(cClient) .AND. cClient<>client
                DbSkip();  LOOP
            ENDI

            cCl := client
            CLIENT->( DbSeek(cCl) )
            IF !Empty(cCont) .AND. At(Upper(cCont),Upper(CLIENT->name))<=0
                DbSkip();  LOOP
            ENDI
            IF !Empty(cKta) .AND. At(Upper(cKta),Upper(CLIENT->comm))<=0
                DbSkip();  LOOP
            ENDI

            //  ᭮ .
            IF !Empty(cReas) .AND. At(Upper(cReas),Upper(comm))<=0
                DbSkip();  LOOP
            ENDI
            IF !Empty(cLab) .AND. At(Upper(cLab),Upper(lab1))<=0
                DbSkip();  LOOP
            ENDI
            IF !Empty(cNumb) .AND. At(cNumb,Upper(number))<=0
                DbSkip();  LOOP
            ENDI

            //  饬  ⠫樨.
            IF !Empty(cCodMin)
                lLoca   := FALSE

                cInv    := codInv
                SELE DETALPRE SEEK cInv
                DO WHIL !Eof() .AND. codInv == cInv
                    IF ASSORMIN->dGr
                        lLoca   := TRUE
                        EXIT
                    ENDI
                    DbSkip()
                ENDD
                SELE PRE_SELL
            ENDI
            IF !lLoca
                DbSkip(); LOOP
            ENDI

            EXIT
        ENDD
        fDeact( cOldCol )

        IF !lLoca .OR. Eof()
            ErrMess(" 襫!",cError); DbGoTo(nRec)
        ENDI
    ELSE                //  ⡮  㯯  ᫮ ᪠.
        fTxt_act("     . ⡨  㯯..",cHelpc)

        //    .
        DbGoTop()
        DO WHIL !Eof()
            lLoca   := TRUE

            //   믨᪨
            IF dBeg > dat .OR. dEnd < dat
                DbSkip();  LOOP
            ENDI

            //  ।.
            IF nAll == 1 .AND. !dAlloc
                DbSkip(); LOOP
            ENDI
            IF nAll == 2 .AND. dAlloc
                DbSkip(); LOOP
            ENDI

            //    㬬 㬥.
            nS          := Round(sum,2)
            IF nBeg > nS .OR. nEnd < nS
                DbSkip();  LOOP
            ENDI

            //  . 㪢   .
            IF !Empty(cClient) .AND. cClient<>client
                DbSkip();  LOOP
            ENDI

            cCl := client
            CLIENT->( DbSeek(cCl) )
            IF !Empty(cCont) .AND. At(Upper(cCont),Upper(CLIENT->name))<=0
                DbSkip();  LOOP
            ENDI

            IF !Empty(cKta) .AND. At(Upper(cKta),Upper(CLIENT->comm))<=0
                DbSkip();  LOOP
            ENDI

            //  ᭮ .
            IF !Empty(cReas) .AND. At(Upper(cReas),Upper(comm))<=0
                DbSkip();  LOOP
            ENDI
            IF !Empty(cLab) .AND. At(Upper(cLab),Upper(lab1))<=0
                DbSkip();  LOOP
            ENDI
            IF !Empty(cNumb) .AND. At(cNumb,Upper(number))<=0
                DbSkip();  LOOP
            ENDI

            //  饬  ⠫樨.
            IF !Empty(cCodMin)
                lLoca   := FALSE

                cInv    := codInv
                SELE DETALPRE SEEK cInv
                DO WHIL !Eof() .AND. codInv == cInv
                    IF ASSORMIN->dGr
                        lLoca   := TRUE
                        EXIT
                    ENDI
                    DbSkip()
                ENDD
                SELE PRE_SELL
            ENDI

            //  砥  㯯.
            IF lLoca
                RecLock(-1)
                dGr     := !dGr
            ENDI
            DbSkip()
        ENDD
        DbGoTo(nRec)
        UN_COMM
        fDeact( cOldCol )
    ENDI
    RETU

* ---------------------------------------------------------------------------
*    窨   ᫮ ⥬ ᪠  F5
*   1302: 㭮  孮 뢠 樨 㤠 - 筮 㤠
PROC pDeleteGrz()
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), lLoca:=FALSE, cInv:="", nS:=0, cCl:=""
    LOCA dBeg:=Ctod(""), dEnd:=Date(), nBeg:=0, nEnd:=999999999.99, cReas:=""
    LOCA cCont:="", cKta:=Spac(12), cLab:=Spac(10), nAll:=3
    LOCA nC:=PRE_SELL->(LastRec()), nJ:=0
    LOCA sOp:="0750"
    S_PROC
    cReas   := Left(cReas+Spac(20),20)
    cCont   := Left(cCont+Spac(10),10)

    //  ⠥ ࠬ ᪠  
    fsWopen(18,1,5,76,cError,2)
    @ 1,1 SAY " 㤠  ।:  ਮ   ........  ........"
    @ 2,1 SAY "ࢠ 㬬  ............  ............     祣 ...."
    @ 3,1 SAY "㪢   ..........  ............  ᭮ ...................."
    @ 4,1 SAY "㪢   .......... ।  1-।.,2-,3- ."
    @1,55 GET dBeg
    @1,67 GET dEnd                      VALI lValid({||dBeg<=dEnd}," 砫쭮!")
    @2,18 GET nBeg  PICT "999999999.99" VALI lValid({||nBeg>=0},"⥫쭠 㬬!")
    @2,34 GET nEnd  PICT "999999999.99" VALI lValid({||nEnd>=nBeg}," ⮢!")
    @2,71 GET cClient                   VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
    @3,16 GET cCont
    @3,31 GET cKta
    @3,55 GET cReas
    @4,13 GET cLab
    @4,74 GET nAll  PICT "9"
    READ
    fDeact( cOldCol )
    AP__INPUT

    cReas   := AllTrim(cReas)
    cCont   := Alltrim(cCont)
    cKta    := Alltrim(cKta)
    cLab    := Alltrim(cLab)

    S_ERROR
    IF !Fyn(" ⢨⥫쭮  㤠  !",cError) THEN RETU

    //  1302   㭮   뢠 -  㧠  ⪨ ⪨
    fTxt_act("      㤠 ...    !",cHelpc)
    lBlockGroup({"PRE_SELL","DETALPRE"})
    REPL ALL dGr WITH FALSE
    fDeact( cOldCol )

    pOpenView( cMainc, cError, "   浪 ஢ ᯨ᪠...",TRUE )
    DbGoTop()
    DO WHIL !Eof()
        BR_REPORT
        pChangeView( ++nJ*100/nC )

        //   믨᪨
        IF dBeg > dat .OR. dEnd < dat
            DbSkip();  LOOP
        ENDI

        //  ।.
        IF nAll == 1 .AND. !dAlloc
            DbSkip(); LOOP
        ENDI
        IF nAll == 2 .AND. dAlloc
            DbSkip(); LOOP
        ENDI

        //    㬬 㬥.
        nS          := Round(sum,2)
        IF nBeg > nS .OR. nEnd < nS
            DbSkip();  LOOP
        ENDI

        //  . 㪢   .
        IF !Empty(cClient) .AND. cClient<>client
            DbSkip();  LOOP
        ENDI

        cCl := client
        CLIENT->( DbSeek(cCl) )
        IF !Empty(cCont) .AND. At(Upper(cCont),Upper(CLIENT->name))<=0
            DbSkip();  LOOP
        ENDI
        IF !Empty(cKta) .AND. At(Upper(cKta),Upper(CLIENT->comm))<=0
            DbSkip();  LOOP
        ENDI

        //  ᭮ .
        IF !Empty(cReas) .AND. At(Upper(cReas),Upper(comm))<=0
            DbSkip();  LOOP
        ENDI
        IF !Empty(cLab) .AND. At(Upper(cLab),Upper(lab1))<=0
            DbSkip();  LOOP
        ENDI

        //   ⥪饣 .
        SELE DETALPRE SEEK PRE_SELL->codInv
        DELE WHIL codInv == PRE_SELL->codInv

        SELE PRE_SELL
        dGr := TRUE
        DbSkip()
    ENDD

    /*   뢠  ⠫権 㤥 㤠   蠯 祭 
         ந 㤠 蠯 㤠 .  㤥 ४ */
    SELE PRE_SELL
    DELE FOR dGr
    pCloseView()
    DbGoTop()
    UNLOCK_COMMIT

    RETU

* ---------------------------------------------------------------------------
*    ।⥫ .  ᠬ 㤠.   蠯
*    ० ⠭  뢠饩 楤.
STAT PROC pReestrPre()
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), nOrd:=zOrd(), lLoca:=FALSE, cInv:="", nS:=0, cCl:=""
    LOCA nPage:=0, nStr:=999999, nI:=0, nRep:=130, nDet:=2, nPp:=0, nn:=0
    LOCA dBeg:=Ctod(""), dEnd:=Date(), nBeg:=0, nEnd:=999999999.99, cReas:="", cCont:="", nAll:=3, cKta:=Spac(12)
    LOCA nSum:=0, nVes:=0, nVol:=0, nnSum:=0, nnVes:=0, nnVol:=0, cTxt:=""
    LOCA nPak:=0, nVs:=0, nVl:=0, cLab:=Spac(10)
    cReas   := Left(cReas+Spac(20),20)
    cCont   := Left(cCont+Spac(10),10)

    //  ⠥ ࠬ ᪠  
    fsWopen(18,1,5,76,cColor,2)
    @ 1,1 SAY " ।:           ਮ ।  ........  ........"
    @ 2,1 SAY "ࢠ 㬬  ............  ............     祣 ...."
    @ 3,1 SAY "㪢   ..........  ............  ᭮ ...................."
    @ 4,1 SAY "㪢   .......... 1- ⠫. . ।.  1-.,2-,3- ."
    @1,55 GET dBeg
    @1,67 GET dEnd                      VALI lValid({||dBeg<=dEnd}," 砫쭮!")
    @2,18 GET nBeg  PICT "999999999.99" VALI lValid({||nBeg>=0},"⥫쭠 㬬!")
    @2,34 GET nEnd  PICT "999999999.99" VALI lValid({||nEnd>=nBeg}," ⮢!")
    @2,71 GET cClient                   VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
    @3,16 GET cCont
    @3,31 GET cKta
    @3,55 GET cReas
    @4,13 GET cLab
    @4,35 GET nDet  PICT "9"
    @4,74 GET nAll  PICT "9"
    READ
    fDeact( cOldCol )
    AP__INPUT

    //   ࠧ 뢮  ⥪⮢ 䠩, 뢠 ஬ ⮣.
    cReas   := AllTrim(cReas)
    cCont   := Alltrim(cCont)
    cKta    := Alltrim(cKta)
    cLab    := Alltrim(cLab)
    cTxt    := zTemp(cdTemp,"TXT",32)

    fTxt_act("    ஥ ...",cOther)
    O____A
    SELE PRE_SELL ORDE PR_DAT_NUMBER
    SET SOFT ON
    DbSeek( Dtos(dBeg) )
    SET SOFT OFF
    DO WHIL !Eof() .AND. dat <= dEnd
        X_DEMO

        //   ᥢ ᥩ. ।.
        IF nAll == 1 .AND. !dAlloc
            DbSkip(); LOOP
        ENDI
        IF nAll == 2 .AND. dAlloc
            DbSkip(); LOOP
        ENDI

        //    㬬 㬥.
        nS          := Round(sum*(1-discount/100),2)
        IF nBeg > nS .OR. nEnd < nS
            DbSkip();  LOOP
        ENDI

        //  . 㪢   .
        IF !Empty(cClient) .AND. cClient<>client
            DbSkip();  LOOP
        ENDI

        cCl := client
        CLIENT->( DbSeek(cCl) )
        IF !Empty(cCont) .AND. At(Upper(cCont),Upper(CLIENT->name))<=0
            DbSkip();  LOOP
        ENDI
        IF !Empty(cKta) .AND. At(Upper(cKta),Upper(CLIENT->comm))<=0
            DbSkip();  LOOP
        ENDI

        //  ᭮ .
        IF !Empty(cReas) .AND. At(Upper(cReas),Upper(comm))<=0
            DbSkip();  LOOP
        ENDI
        IF !Empty(cLab) .AND. At(Upper(cLab),Upper(lab1))<=0
            DbSkip();  LOOP
        ENDI

        //  뢮  㬥.
        nnSum   := nnVes    := nnVol    := 0
        SELE DETALPRE SEEK PRE_SELL->codInv
        DO WHIL !Eof() .AND. codInv == PRE_SELL->codInv
            IF nStr > nLenSt
                IF nPage > 0 THEN ? Chr(12)
                ? Padc(" 믨ᠭ   ਮ  "+Dtoc(dBeg)+"  "+Dtoc(dEnd)+" ६ "+Time(),nRep-8)+". "+Str(++nPage,3)
                ? Repl("-",nRep)
                ? "/|             ⨬             |     |⢮|   㬬  ||.+  ||     | ꥬ |."
                ? Repl("-",nRep)
                nStr    := 6
            ENDI

            //  ।  ⨬
            ASSORMIN->( DbSeek(DETALPRE->codMin) )

            //  । 稥 ४ ⮢஢,  ⮬ ᫥  娢
            SELE WARES SEEK DETALPRE->codMin
            IF Eof()
                SELE ARCWARES SEEK DETALPRE->codMin
            ENDI
            nPak    := qtyPak
            nVs     := vesPak
            nVl     := volPak
            SELE DETALPRE

            IF nDet == 1    //  ࠦ  ⠫樥
                ?   Spac(3)+" "+ASSORMIN->name+" "+Str(sales*(1-PRE_SELL->discount/100),9,2)+" "+Str(qtyAll,10,3)+" "+Str(qtyAll*sales*(1-PRE_SELL->discount/100),10,2)+" "+Str(nPak,3)+" "
                ??  Str(zInt(qtyAll/nPak),5)+"+"+Str(qtyAll-nPak*zInt(qtyAll/nPak),8,3)+" "+stat+" "+Str(qtyAll*nVs/nPak,8,1)+" "+Str(qtyAll*nVl/nPak,7,1)+" "+Str(qty,5)
                ++nStr
            ENDI

            //   ⮣ ᥣ   㬥
            nSum    += sales*qtyAll*(1-PRE_SELL->discount/100)
            nVes    += qtyAll*nVs/nPak
            nVol    += qtyAll*nVl/nPak
            nnSum   += sales*qtyAll*(1-PRE_SELL->discount/100)
            nnVes   += qtyAll*nVs/nPak
            nnVol   += qtyAll*nVl/nPak
            DbSkip()
        ENDD

        //  뢮  㬥.
        SELE PRE_SELL
        ?  Str(++nPp,3)+" N_"+number+" ⠇ "+Dtoc(dat)+"  "+Left(Dtoc(datInv),5)+" .. "+timInv+" . "+Dtoc(endDat)+" . "+IF(pay=="1","",IF(pay=="2","/","/"))+" / "+IF(sch," ","")+;
           "  "+Str(nnVes,12,3)+" ."+Str(nnVol,6)
        ++nStr

        CLIENT->( DbSeek(PRE_SELL->client) )
        ? "㯠⥫ "+CLIENT->name+" "+client+" 㬬 "+Str(nnSum,12,2)+" . "+Str(discount,10,6)+" "+Left(comm,28)
        ++nStr

        ? " "+CLIENT->comm+"  "+cAdress_d(PRE_SELL->client,PRE_SELL->codAdr)
        ++nStr
        ? Repl("-",nRep)
        ++nStr
        SELE PRE_SELL SKIP
    ENDD
    ? "⮣  ᥬ .  "+Str(nVes,12,3)+" ꥬ "+Str(nVol,12,5)+" 㬬 "+Str(nSum,15,2)+CRLF+Chr(12)
    C____A
    fDeact(cOldCol)
    pFileOutDevice( cTxt, 132, 6 )
    Ferase( cTxt )

    //   ﭨ ணࠬ.
    SELE PRE_SELL ORDE (nOrd) REC (nRec)
    RETU

* ---------------------------------------------------------------------------
*   㡫஢ ।  ⪮ ଠ樨  । .
PROC pDublPre()
    LOCA cOldCol:=SetColor(), aInv:={}, cInv:=codInv, nRec:=RecNo()
    LOCA cDbf:="", c:="", nI:=0, aDet:={}, cCod:="", coInv:=codInv, coc:=client
    LOCA sOp:="0738"
    S_PROC

    IF !Fyn("  ᤥ  ⥪饣 ?",cHelpc) THEN RETU

    //  ਧ 饭  㬥.
    IF Empty(codInv)
        ErrMess("!",cError); RETU
    ENDI

    ftxt_act("     !",cHelpc)

    //   ६ ᨢ  ᭮ ⠫樨  ().
    cDbf    := zTemp(cdTemp,"DBF",32)

    SELE DETALPRE
    COPY STRU TO (cDbf)

    LanUse("",cDbf,NO_INDEX,"TEMP",EXCL_MODE,-1,NEW_SEL)

    //  ७ ⠫  ६ﭪ.
    SELE DETALPRE SEEK cInv
    DO WHIL !Eof() .AND. codInv == cInv
        X_DEMO

        aDet    := {}
        FOR nI:=1 TO Fcount() DO Aadd(aDet,FieldGet(nI))

        SELE TEMP APPE
        FOR nI:=1 TO Fcount() DO FieldPut(nI,aDet[nI])
        qty := 0

        SELE DETALPRE SKIP
    ENDD

    //  ७   ᨢ.
    SELE PRE_SELL
    FOR nI:=1 TO Fcount() DO Aadd(aInv,FieldGet(nI))

    //    ।⥫쭮 । .
    cCod    := cGenCode(PR_CODINV,4,"codInv")
    lBlockGroup({"PRE_SELL","DETALPRE"})

    SELE PRE_SELL
    DbAppend()
    FOR nI:=1 TO Fcount() DO FieldPut(nI,aInv[nI])

    //       㫥 .
    REPL codInv WITH cCod, dAlloc WITH FALSE, status WITH FALSE, dGr WITH FALSE

    SELE TEMP
    REPL ALL codInv WITH cCod

    //   ⠫  .
    SELE TEMP TOP
    DO WHIL !Eof()
        X_DEMO

        aDet    := {}
        FOR nI:=1 TO Fcount() DO Aadd(aDet,FieldGet(nI))

        SELE DETALPRE APPE
        FOR nI:=1 TO Fcount() DO FieldPut(nI,aDet[nI])

        SELE TEMP SKIP
    ENDD

    //   ﭨ । ணࠬ.
    TEMP->( DbCloseArea() )
    ferase( cDbf )

    SELE PRE_SELL
    DbGoTo( nRec )
    UNLOCK_COMMIT

    fDeact(cOldCol)

    pAppJornal(sOp,1,"  । "+coInv+"  ।.   "+cCod+"  㯠⥫ "+coc+" "+cNameCl(coc))
    pinStat(sOp,0)
    RETU

* ---------------------------------------------------------------------------
* । ࠢ筮 ଠ樨   /।  祣 
STAT FUNC lInpPayNO()
    LOCA cOldCol:=SetColor(), nLim:=sum*(1-discount/100)
    LOCA nOld:=sumPut, nSum:=nLim-sumPut
    LOCA sOp:="0705"
    S_FUNC

    IF status
        ErrMess("饭 ४஬  㬥!",cError); RETU FALSE
    ENDI

    fswOpen(21,27,2,50,cOther,2)
    @ 1,1 SAY " 饭 㬬  (+-)" GET nSum   PICT "999999999.99";
          VALI lValid({||nLim-sumPut-nSum>=0},"砥 ⥫   !") .AND. lValid({||sumPut+nSum<=nLim}," ॢ蠥 㬬  !")
    READ
    fDeact(cOldCol)
    AF__INPUT

    RecLock(-1)
    sumPut  += nSum
    UN_COMM

    pAppJornal(sOp,1,codInv+"     "+Dtoc(dat)+" 㬬 "+Str(nOld,12,2)+"("+Str(sumPut,12,2)+"  "+client+" "+cNameCl(client))
    pinStat(sOp,0)
    RETU TRUE

* ---------------------------------------------------------------------------
*  ८ࠧ ।  㠫 㬥     ⠭
*   03.2011 뫠 ᨣ  ० ᯥ. 㬥⮢  ࠡ⪨ 
*   06.2013  ⮢ 䠪  冷 ப  ࠬ  㬮砭  ᨨ 1305
*   04.2014   㭨ᠫ쭮 ।筮 㬥
*   07.2014  ०  ࠬ஢ ᯥ毥   ⮢ 䠪
PROC pVirt(nMode)
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), nC:=LastRec(), nJ:=0, aNo:={}
    LOCA cDbf:="", cDbd:="", cNtd:=""
    LOCA dDat:=dat, cNumber:=number, cPay:=pay, nProv:=IF(dProv,1,2)
    LOCA dEndDat:=endDat, ntipReal:=1, cInv:=codInv
    LOCA nN:=0, nT:=0, cMin:="", cWar:="", nSum:=0
    LOCA cfSh:=Spac(12), cfPod:=Spac(12), nXbm:=0
    LOCA clDoc:=Spac(30), clDat:=Spac(50), cOth:=Spac(50), cCl:="", cCl1:=""
    LOCA ccc:="", nOut:=1, nReturn:=2, nPr:=0, nPrih:=1, nRosp:=2
    LOCA nNewNds:=(-1), nAk:=IF(lpInventAk,2,1)
    LOCA cOldNo:=cNo        //  ࠭ 祭 쭮 ६ - १  ᨣ   ⠢.

    cClient := cClient1 := client
    cCodAdr := codAdr
    cTabel  := cTabStock
    cTabel1 := cTabWorker
    csReas  := comm
    cNo     := "PRE_SELL"   //  

    //***    ⠡  ନ 䠩   ⠫樨.
    cDbf    := zTemp(cdTemp,"DBF",32)
    cDbd    := zTemp(cdTemp,"DBF",32)
    cNtd    := zTemp(cdTemp,"NTX",32)

    //    㧮筮  ( ।)
    SELE INVOICES
    COPY STRU TO (cDbf)
    LanUse("",cDbf,NO_INDEX,"VIRT_INV",EXCL_MODE,-1,NEW_SEL)

    SELE DETALINV
    COPY STRU TO (cDbd)
    LanUse("",cDbd,NO_INDEX,"VIRT_DET",EXCL_MODE,-1,NEW_SEL)
    SELE VIRT_DET
    INDE ON codWares TO (cNtd)

    //  ७ ଠ  ।  㠫 㬥.
    SELE DETALPRE SEEK cInv
    DO WHIL !Eof() .AND. codInv == cInv
        cMin    := codMin

        //  ᫨ ⨬   -   ⮢
        SELE WARES SEEK cMin
        IF Eof()
            SELE ARCWARES SEEK cMin
            IF Eof()
                SELE DETALPRE SKIP
                LOOP
            ENDI
        ENDI
        cWar    := codWares
        nN      := pnds
        nT      := tax_s

        //   㠫 ⠫.
        SELE VIRT_DET APPE
        REPL codInv WITH "ZZZZ", codWares WITH cWar, tax_n WITH nN, tax_s WITH nT
        REPL qtyAll WITH DETALPRE->qtyAll, sales WITH DETALPRE->sales, stat WITH DETALPRE->stat
        nSum    += sales*qtyAll

        SELE DETALPRE SKIP
    ENDD

    //  ।뢠   ⠫樨
    SELE VIRT_DET
    INDE ON codInv TO (cNtd)

    //  ଫ 蠯 㬥.
    SELE VIRT_INV APPE
    REPL codInv WITH "ZZZZ", codStores WITH "", dat WITH dDat, sum WITH nSum, discount WITH PRE_SELL->discount
    REPL endDat WITH dEndDat, pay WITH cPay, client WITH cClient, codAdr WITH cCodAdr
    REPL dProv WITH (nProv==1), tabel WITH cTabel, keeping WITH TRUE
    REPL tipReal WITH ntipReal, number WITH cNumber, reason WITH csReas
    REPL client_out WITH cClient1, tabel3 WITH cTabel1

    //  ६  ⠭   ⮢஢.
    SELE ARCWARES ORDE AW_CODWARES
    SELE WARES    ORDE W_CODWARES
    SELE VIRT_INV

    //***   ࠡ⪠ ⨯ ⠥ 㬥.
    DO CASE
    CASE nMode == 1     //    ।⥫ .
        pSpAccInv()
    CASE nMode == 2             //    ⨯.
        pSpecPrInv([Z],"ZZZZ")  //  UNIVER
    CASE nMode == 4             //  ᠫ । 㬥
        pSpUnPerDoc({dDat,cNumber,[],[],[]}) //  PRINTUPD
    CASE nMode == 5             //    䠪 १ ०  ࠬ஢ ᯥ毥
        IF ValType(apFact[13]) == "N"

            //  ⠭ ࠬ ᯥ毥  ६ 
            nOut        := apFact[13]   //  室騩 /
            nReturn     := apFact[14]   //   
            nPr         := apFact[15]   //  ⨯ 業
            cClient     := apFact[16]   //     
            cClient1    := client       //   - ᯮ
            cClient2    := apFact[18]   //  㧮ࠢ⥫
            cClient3    := apFact[19]   //  㧮⥫
            cTabel2     := apFact[20]   //  믨ᠫ /
            nPrih       := apFact[21]   //  㧪 - 業     த
            nAk         := apFact[22]   //  ਧ,   㬬 樧 㫥
            cfSh        := apFact[23]   //    䠩 ( 䠩)
            cfPod       := apFact[24]   //  , ᠭ  䠩
            nRosp       := apFact[25]   //  室 ᯨᥩ
            nXbm        := apFact[26]   //  ஢ १ 
            nNewNds     := apFact[29]   //  饭    祭
            aNo         := apFact[31]   //   - ᨢ  । ⥫ ࠬ஢

            //   ᨢ 㠫쭮 㬥  䠪᪨ ४ 
            aNo[1]      := dDat
            aNo[2]      := cNumber
            aNo[3]      := cOth
            aNo[4]      := clDoc
            aNo[5]      := clDat

            IF nXbm >= 1;   psPrUnXbm(cClient1, ((nOut=1).AND.(nReturn<>1)).OR.((nOut<>1).AND.(nReturn=1)), cClient2, cClient3, (nOut=1), cClient, nPr, !(nPrih=1),(nRosp=2),(nAk=2),aNo,aConvert(cfSh),aConvert(cfPod),nXbm,"","",nNewNds)
            ELSE;           pPrSchFaAll(cClient1, ((nOut=1).AND.(nReturn<>1)).OR.((nOut<>1).AND.(nReturn=1)), cClient2, cClient3, (nOut=1), cClient, nPr, !(nPrih=1),(nRosp=2),(nAk=2),aNo,aConvert(cfSh),aConvert(cfPod),"",nNewNds)
            ENDI
        ELSE
            ErrMess(" 砫 ᤥ ᯥ.  ଠ쭮!",cError)
        ENDI
    CASE nMode == 6             //    १ ०  ࠬ஢ ᯥ毥
        IF ValType(apFact[1]) == "N"
            pSpecPrInv([Z],"ZZZZ",TRUE)
        ELSE
            ErrMess(" 砫 ᤥ ᯥ.  ଠ쭮!",cError)
        ENDI
    OTHE                                //   䠪  ᯥ樠쭮 ࠡ⪮.
        ccc     := client               //   ࠭塞
        cClient := Spac(4)              //   த -  㬮砭
        cClient1:= ccc                  //  㯠⥫   
        cClient2:= cClient3 := Spac(4)  //  㧫   㬮砭
        cTabel2 := Spac(4)+"."          //  䨪  .

        //   䠩 ᯨᥩ 㯮祭    ன ணࠬ
        cfPod   := IF(!Empty(cgFilePod),Left(Alltrim(cgFilePod)+Spac(12),12),Spac(12))

        //    ⠥ ࠬ ன   . 1306 -  冷 ᮢ
        fSwopen(4,3,19,75,cOther,1)
        @ 1,1  SAY "- ஢, ᫨ 㬥  १ ⥬   Win ଥ ."
        @ 2,1  SAY " ।    ........  ............ /"
        @ 3,1  SAY "᮪ ஢ ⥦ 㬥⮢           ............................"
        @ 4,1  SAY "                   ................................................"
        @ 5,1  SAY "(  )   ................................................"
        @ 6,1  SAY "  1, ᫨ ନ஢ 室騩  䠪                 ."
        @ 7,1  SAY " 1, ᫨   䠪   ⮢஢                     ."
        @ 8,1  SAY ": 0-, 1-㯠, 2- ., 3-1...6-4, 12-(-)           "
        @ 9,1  SAY "   塞   祣                         ...."
        @10,1  SAY "    ᯮ  䠪  祣  ...."
        @11,1  SAY " 㧮ࠢ⥫  祣, ᫨  㬮砭                    ...."
        @12,1  SAY " 㧮⥫  祣, ᫨  㬮砭                     ...."
        @13,1  SAY " 2-᫨ 㬬 樧 ਭ㤨⥫쭮  㫥                   ."
        @14,1  SAY " 䠩 ᮤঠ饣 ⥪ ࠦ  蠯 㬥      ............"
        @15,1  SAY " 䠩 ᮤঠ饣 ⥪ ࠦ   㬥    ............"
        @16,1  SAY " 2-᫨ 室 ஢  㪮⥫  ..       ."
        @17,1  SAY "業 , ᫨  ⠢  (-1) - ⠢          .."
        @18,1  SAY "*ࠬ ᯥ毥      ⨯ 㬥⮢*"  COLO cHelpc

        @1,74  GET nXbm     PICT "9"
        @2,40  GET dDat                 VALI lValid({||dDat >= dat},"   (।)!")
        @2,55  GET cNumber  PICT "@K"
        @3,45  GET clDoc
        @4,25  GET clDat
        @5,25  GET cOth
        @6,74  GET nOut     PICT "9"
        @7,74  GET nReturn  PICT "9"
        @8,73  GET nPr      PICT "99"   VALI lValid({||(nPr>=0.AND.nPr<=6).OR.(nPr=12)},"୮ 祭!")
        @9,71  GET cClient              VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
        @10,71 GET cClient1             VALI IF(Empty(cClient1),TRUE,Eval(bClient,cClient1))
        @11,71 GET cClient2             VALI IF(Empty(cClient2),TRUE,Eval(bClient,cClient2))
        @12,71 GET cClient3             VALI IF(Empty(cClient3),TRUE,Eval(bClient,cClient3))
        @13,74 GET nAk      PICT "9"
        @14,63 GET cfSh
        @15,63 GET cfPod
        @16,74 GET nRosp    PICT "9"
        @17,73 GET nNewNds  PICT "99"
        READ
        fDeact( cOldCol )
        IF LastKey() <> K_ESC

            //  ⠥  䠪 ᮮ⢥騩  / 䨪⨢.
            aadd(aNo,dDat)
            aadd(aNo,cNumber)
            aadd(aNo,cOth)
            aadd(aNo,clDoc)
            aadd(aNo,clDat)

            //  ࠭ ࠬ  ᨢ ࠭ ࠬ஢ ᯥ毥
            cTabel2 += "."  //  -  ⠫  㣨 .
            apFact[13]  := nOut         //  室騩 /
            apFact[14]  := nReturn      //   
            apFact[15]  := nPr          //  ⨯ 業
            apFact[16]  := cClient      //     
            apFact[17]  := cClient1     //   - ᯮ
            apFact[18]  := cClient2     //  㧮ࠢ⥫
            apFact[19]  := cClient3     //  㧮⥫
            apFact[20]  := cTabel2      //  믨ᠫ /
            apFact[21]  := 1            //  㧪 - 業     த
            apFact[22]  := nAk          //  ਧ,   㬬 樧 㫥
            apFact[23]  := cfSh         //    䠩 ( 䠩)
            apFact[24]  := cfPod        //  , ᠭ  䠩
            apFact[25]  := nRosp        //  室 ᯨᥩ
            apFact[26]  := nXbm         //  ஢ १ 
            apFact[27]  := ""           //  訩 ଠ  
            apFact[28]  := ""           //  ਭ㤨⥫쭠 ⪠ ࠭ ந宦
            apFact[29]  := nNewNds      //  饭    祭
            apFact[31]  := aNo          //   - ᨢ  । ⥫ ࠬ஢

            IF nXbm >= 1;   psPrUnXbm(cClient1, ((nOut=1).AND.(nReturn<>1)).OR.((nOut<>1).AND.(nReturn=1)), cClient2, cClient3, (nOut=1), cClient, nPr, !(nPrih=1),(nRosp=2),(nAk=2),aNo,aConvert(cfSh),aConvert(cfPod),nXbm,"","",nNewNds)
            ELSE;           pPrSchFaAll(cClient1, ((nOut=1).AND.(nReturn<>1)).OR.((nOut<>1).AND.(nReturn=1)), cClient2, cClient3, (nOut=1), cClient, nPr, !(nPrih=1),(nRosp=2),(nAk=2),aNo,aConvert(cfSh),aConvert(cfPod),"",nNewNds)
            ENDI
        ENDI
    ENDC

    //***    ﭥ । ணࠬ.
    cNo     := cOldNo   //  ஥ 祭 ᥬ -   㦥 ᯮ짮.
    VIRT_INV->( DbCloseArea() )
    VIRT_DET->( DbCloseArea() )
    ferase(cDbf)
    ferase(cDbd)
    ferase(cNtd)

    //   直 砩   ⮢஢.
    SELE ARCWARES ORDE AW_CODMIN
    SELE WARES    ORDE AW_CODMIN
    SELE PRE_SELL
    RETU

* ---------------------------------------------------------------------------
*     ⮢ࠬ ᯥ. ࠩ . ࠭祭 ஥  -
PROC pAddSarcis()
    LOCA cOldCol:=SetColor(), cInv:="", nSum:=0, lNil:=TRUE, nPay:=1, cnCl:="", cnAdr:=""
    LOCA oTb, oCol, nKeys:=0, GetList:={}, cCont:="", nR:=0, lSeek:=FALSE
    LOCA dDat:=Date(), cNumber:=cAutoNumb("PRE_SELL",PR_CODINV)
    LOCA cOpTime:=Time(), dDatInv:=Date()+1, cTimInv:="08:00-20:00"
    LOCA dEndDat:=Date()+1, cPay:="1", nDiscount:=0, nProv:=IF(lpProvDoc,1,2), nSch:=2
    LOCA cDbf:="", cNtx:="", cPrice:="", cMin:=""
    LOCA aDbf:={{"name",    "C",    50, 0},;
                {"codMin",  "C",    4,  0},;
                {"sales",   "N",    10, 2},;
                {"qtyAll",  "N",    10, 3}}
    LOCA sOp:="0765"
    S_PROC

    //  । ࠢ ६
    cClient     := cCodAdr  := Spac(4)
    csReas      := Spac(72)
    cSent3      := Spac(25)

    //   ࠭  ⠥ 騥 ࠬ   ६.
    fSwopen(1,1,10,39,cOther,3)
    @ 1,1 SAY "   㯠⥫"       GET cClient             VALI Eval(bClient,cClient) .AND.;
          lValid({||!Empty(CLIENT->codPrice)}," 㯠⥫  ࠩ!") .AND. Eval({||lCrPay(@nPay,cClient),cPay:=Str(nPay,1),cPrice:=CLIENT->codPrice,TRUE})
    @ 2,1 SAY "  ⠢ ⮢஢      "       GET cCodAdr             VALI lStAdr(TRUE)
    @ 3,1 SAY "                   "           GET dDat
    @ 4,1 SAY "                 "               GET cNumber   PICT "@K"
    @ 5,1 SAY " -⠢ ⮢. "           GET dDatInv             VALI lValid({||dDatInv>=dDat},"     !") .AND. Eval({||dEndDat:=dDatInv,TRUE})
    @ 6,1 SAY " (1-,2-,3-/.)"    GET cPay                VALI lValid({||cPay=="1".OR.cPay=="2".OR.cPay=="3"},"ୠ ଠ !")
    @ 7,1 SAY "易⥫쭮 (1-,2-)"    GET nProv     PICT "9"  VALI lValid({||nProv==1.OR.nProv==2},"ࠢ쭮 1  2!")
    @ 8,1 SAY "室 /䠪(1-,2-)"    GET nSch      PICT "9"  VALI lValid({||nSch==1.OR.nSch==2},"ࠢ쭮 1  2!")
    @ 9,1 SAY "."                                    GET csReas    PICT "@S33"
    READ
    fDeact(cOldCol)
    AP__INPUT

    //     ६ﭪ ﬨ  ᯥ.ࠩ,  .  㫥묨 業
    ftxt_act("㭤...",cHelpc)
    cnCl        := CLIENT->name
    IF !Empty(cCodAdr)
        ADRESS_D->( DbSeek(cClient+cCodAdr) )
        cnAdr   := ADRESS_D->adress
    ELSE        //   㪠뢠  
        cnAdr   := ""
    ENDI

    cDbf    := zTemp(cdTemp,"DBF",32)
    cNtx    := zTemp(cdTemp,"NTX",32)

    DbCreate(cDbf,aDbf)
    LanUse("",cDbf,NO_INDEX,"TEMP",EXCL_MODE,-1,NEW_SEL)
    INDE ON Upper(name)+codMin TO (cNtx)

    SELE PRICE_CL SEEK cPrice   //   RELA c ASSORMIN
    DO WHIL !Eof() .AND. codPrice == cPrice
        cMin    := codMin
        IF endSal > 0            //    㫥묨 業
            SELE TEMP APPE
            ASSORMIN->( DbSeek(cMin) )
            REPL name WITH ASSORMIN->name, codMin WITH PRICE_CL->codMin, sales WITH PRICE_CL->endSal
        ENDI
        SELE PRICE_CL SKIP
    ENDD
    fDeact(cOldCol)

    //   ਭ樯  த १ ⪨ ࠡ뢠 ⠡ -  ॡ㥬 -
    CLEA TYPE
    SELE TEMP TOP

    //  ⨢㥬 쥪 - ⠡  ᬮ ⪮  ᪫.
    fSwopen(0,0,24,79,cColor,3)
    @ 0,21 SAY "Enter/ -  ⢠  F5 -   Esc - " COLO cMainc
    @ 23,1 SAY Repl("-",5)+" "+Left(Alltrim(cnCl)+" "+Repl("-",80),72) COLO cMainc
    IF !Empty(cnAdr)
        @ 24,1 SAY " "+Left(cnAdr,77) COLO cHelpc
    ENDI
    oTB         := TBrowseDB(1,1,22,78)
    oTb:headSep := ""
    oTb:colSep  := ""

    // ᠭ  ⠡.
    oTB:addColumn( TBColumnNew(" .",{||qtyAll}) )
    oTB:addColumn( TBColumnNew("               ⨬             ࠩ",{||name+" "+codMin+" "+Str(sales,10,2)}) )

    DO WHIL TRUE
        DO WHIL !(oTB:stabilize())      //   蠣 ⠡ 쥪    ࢠ
            IF Inkey()<>0 THEN EXIT     //  뢠 ⠡樨
        ENDD

        IF oTB:stable                   //  ᫨ 쥪  ⠡஢
            _TOP_BOTTOM                 //    ⨦ 砫  
        ENDI

        nKeys := Inkey(0)               //  ᪮筮   

        //***        ᫮   ࠡ稪.
        IF oTb:colPos == 1              //   塞 .
            IF IsDigit(Chr(nKeys))
                CLEA TYPE
                KEYB Chr(K_ENTER)+Chr(nKeys)
                LOOP
            ENDI
        ENDI
        PStandartKeys(oTB,nKeys)        //  ࠡ稪 ⠭ 

        oTB:stabilize()
        DO CASE
        CASE nKeys == K_F5      //    ⥪饣 .

            fSwopen(19,21,2,56,cOther,2)
            cCont   := Left(cCont+Spac(20),20)
            nR      := RecNo()
            lSeek   := FALSE
            @ 1,1 SAY " 㪢      "           GET cCont
            READ
            fDeact( cColor )
            IF LastKey() <> K_ESC
                cCont   := Upper(AllTrim(cCont))
                DbSkip()
                DO WHIL !Eof()
                    IF !Empty(cCont)
                        IF At(cCont,Upper(name)) == 0
                            DbSkip(); LOOP
                        ENDI
                    ENDI
                    lSeek   := TRUE
                    EXIT
                ENDD

                IF !lSeek
                    ErrMess(" 襫!",cError); DbGoTo(nR)
                ENDI
                fDeact(cColor)
                REF_INV
            ENDI
        CASE nKeys == K_ENTER   //   祭 .
            nSum    -= qtyAll*sales
            IF      oTb:colPos<>1
                ErrMess(" ண ⮫ 饭!",cError)
            ELSE
                @ Row(),Col() GET qtyAll PICT "999999.999" VALI lValid({||qtyAll >= 0},"⥫쭮 ⢮!")
                READ
            ENDI
            nSum    += qtyAll*sales
            oTb:Down()
            REF_INV
        CASE nKeys == K_ESC;    EXIT
        ENDC
        pStab(oTb)

        @ 0,1 SAY Str(nSum,12,2) COLOR cHelpc
    ENDD

    IF Fyn("   "+Alltrim(cnCl)+"?",cHelpc)
        lBlockGroup({"PRE_SELL","DETALPRE"},-1,FALSE)

        //     .
        SELE PRE_SELL
        cInv    := cGenCode(PR_CODINV,4,"codInv")
        nSum    := 0

        //   ⠫    ⢠.
        SELE TEMP TOP
        DO WHIL !Eof()
            IF qtyAll > 0       //   뢠 ⢮

                SELE DETALPRE APPE
                REPL codInv WITH cInv, codMin WITH TEMP->codMin, qtyAll WITH TEMP->qtyAll, sales WITH TEMP->sales
                nSum    += sales * qtyAll

                SELE TEMP
            ENDI
            DbSkip()
        ENDD

        //   蠯 , ᫨  ⠫
        IF nSum > 0
            SELE PRE_SELL APPE
            REPL codInv WITH cInv, dat WITH dDat, number WITH cNumber, opTime WITH cOpTime, datInv WITH dDatInv, TimInv WITH cTimInv
            REPL endDat WITH dendDat, pay WITH cPay, client WITH cClient, discount WITH nDiscount
            REPL dProv WITH (nProv=1), sch WITH (nSch=1), codAdr WITH cAnalAdr(cCodAdr,cClient), comm WITH Upper(csReas), sum WITH nSum
        ENDI
        UNLOCK_COMMIT

        //    ୠ.   ०.
        pAppJornal(sOp,1,"  ࠩ  "+cInv+"  "+Dtoc(dDat)+"  㬬 "+Str(nSum,12,2))
    ENDI

    fDeact(cOldCol)

    SELE TEMP
    DbCloseArea()
    ferase( cDbf )
    ferase( cNtx )

    SELE PRE_SELL
    pinStat(sOp,0)
    RETU

* ---------------------------------------------------------------------------
*   F4 -   ४⮢ 蠯 ।. ⠭ ०
FUNC lChNumbPre()
    LOCA cOldCol:=SetColor(), cNumber:=number, dDat:=dat, dDatInv:=datInv, dEndDat:=endDat
    LOCA sOp:="0707"
    S_FUNC

    //  ६ 騥 祭  ࠢ筨 祢 ࠧ
    csReas      := comm
    cSent3      := lab1

    IF status
        ErrMess("饭 ४஬  㬥!",cError); RETU FALSE
    ENDI

    //    ⠥  祭 ਡ⮢.
    fSwopen(16,43,7,34,cOther,2)
    @ 1,1 SAY " 㬥    "     GET cNumber     PICT "@K"
    @ 2,1 SAY "(F3):"                GET csReas      PICT "@S23"
    @ 3,1 SAY " (F3):"                GET cSent3      PICT "@S23"
    @ 4,1 SAY "             " GET dDat
    @ 5,1 SAY " .    " GET dDatInv     VALI lValid({||dDatInv>=dDat},"  !")
    @ 6,1 SAY "⠎窨      " GET dEndDat     VALI lValid({||dEndDat>=dDatInv},"  !")
    READ
    fDeact( cOldCol )
    AF__INPUT

    //    ୠ.
    pAppJornal(sOp,1," । "+codInv+"  "+Dtoc(dat)+"  ,  "+number+"("+cNumber+")  / ᭮")

    //  襬  .
    RecLock(-1)
    REPL number WITH cNumber, comm WITH csReas, lab1 WITH cSent3
    REPL dat WITH dDat, datInv WITH dDatInv, endDat WITH dEndDat
    UN_COMM
    pinStat(sOp,0)
    RETU TRUE

* ---------------------------------------------------------------------------
*    窨   ⮢ 䠪  .  ࠬ஢ ᯥ-
*   樠஢   㯯 㬥⮢ ।塞  
PROC pPrePrDoc()
    LOCA cOldCol:=SetColor(), nRec:=RecNo(), nOrd:=zOrd(), nR:=0
    LOCA GetList:={}, lExit:=TRUE, nSec:=0, cCl:=""
    LOCA nTip:=3, dBeg:=Date(), dEnd:=Date(), cBeg:=Spac(12), cEnd:=Spac(12)
    LOCA sOp:="0755"
    S_PROC

    //  । ࠢ ६
    cClient     := Spac(4)

    //   ࠭  ⠥ ࠬ ०  㬥⮢.
    fSwopen(16,22,7,55,cOther,3)
    @ 1,1 SAY "   㯠⥫ (F3)  祣"       GET cClient             VALI IF(Empty(cClient),TRUE,Eval(bClient,cClient))
    @ 2,1 SAY " 砫 ਮ 㬥⮢ ()     "           GET dBeg
    @ 3,1 SAY "  砭 ਮ  窨    "           GET dEnd                VALI lValid({||dEnd >= dBeg}," 砫쭮 - !")
    @ 4,1 SAY "砫  ࢠ ஢ "               GET cBeg
    @ 5,1 SAY " . ॢ  ᫮"               GET cEnd
    @ 6,1 SAY "⠥: 1-⮫쪮 , 2-.䠪,       "    GET nTip                PICT "9" 
    READ
    fDeact(cOldCol)
    AP__INPUT
    cCl     := cClient  //   ७祭   뢠 楤

    /*  ஢,   ந ० ᯥ樠஢ 
           () ⮢ 䠪, .. ணࠬ 稫,
          㬥, 㤮⢮騥 ᠬ ० */
    IF (nTip = 1) .OR. (nTip > 2)   //  ஢塞 
        IF ValType(apFact[1]) <> "N"
            ErrMess(" 砫 ᤥ ᯥ樠஢ ,  筮!",cError)
            RETU
        ENDI
    ENDI
    IF (nTip = 1) .OR. (nTip > 2)   //  ஢塞  䠪
        IF ValType(apFact[13]) <> "N"
            ErrMess(" 砫 ᤥ ᯥ樠஢ ,  筮!",cError)
            RETU
        ENDI
    ENDI

    /*  ஢塞 饭 , ᫨  㬥⮢  ᪮ ଠ
         ६ ।, .. ० ᯥ毥 㦥 뢠 */
    IF apFact[26] > 0 .OR. apFact[13] > 0
        IF !lgCheckXbm() THEN RETU
    ENDI

    //   ᯨ᮪ 㬥⮢  ࠭⥫ ०.  ࢠ  
    ftxt_act("             뢠.   砭 ...",cHelpc,TRUE)

    SELE PRE_SELL
    zSet(PR_DAT_NUMBER)
    SET SOFT ON
    DbSeek( Dtos(dBeg) )
    SET SOFT OFF
    DO WHIL !Eof() .AND. dat <= dEnd .AND. Inkey(0.1) <> K_ESC
        @ 1,1 SAY Spac(12)
        X_DEMO

        //***    ᥢ ᥩ  ।
        IF !Empty(cCl) .AND. client <> cCl
            DbSkip(); LOOP
        ENDI

        IF !(Val(Alltrim(number)) <= Val(Alltrim(cEnd)) .AND. Val(Alltrim(number)) >= Val(Alltrim(cBeg)))
            DbSkip(); LOOP
        ENDI
        @ 1,1 SAY number
        nR  := RecNo()

        /*   ࠭祭 ६ 襭 ।饩  ⥬ 
             ᪮ ०      ᮢ   */
        IF apFact[26] > 0 .OR. apFact[13] > 0   //  .०   -䠪
            lExit   := FALSE
            nSec    := 0
            WHIL nSec++ < 60    //  ⪨  ... ਬ  ࠢ 㬠
                IF !( File(cPathXBK+"torg.dbf") .OR. File(cPathXBK+"dtor.dbf") .OR. File(cPathXBK+"wtorg.dbf") .OR. File(cPathXBK+"wdtor.dbf") )
                    lExit   := TRUE
                    EXIT
                ENDI
                Inkey(1)
            END
        ELSE
            Inkey(0.5)
        ENDI
        IF !lExit .OR. !zPrintReady()
            ErrMess(" , 稫 㬠, ஡  .  ⪨  㬥⮢!",cError)
            EXIT
        ENDI

        //   ।  㪠 ⨯ 㬥.
        @ 1,1 SAY number
        IF nTip = 1 .OR. nTip > 2   //    㪠 ଠ
            pVirt(6)
        ENDI

        DbGoTo(nR)
        IF nTip = 2 .OR. nTip > 2   //   䠪  㪠 ଠ
            IF apFact[26] > 0
                nSec    := 0
                WHIL nSec++ < 20
                    IF !(File(cPathXBK+"torg.dbf") .OR. File(cPathXBK+"dtor.dbf") .OR. File(cPathXBK+"wtorg.dbf") .OR. File(cPathXBK+"wdtor.dbf"))
                        EXIT
                    ENDI
                    Inkey(1)
                END
            ELSE
                Inkey(0.5)
            ENDI
            pVirt(5)
        ENDI

        SELE PRE_SELL
        DbGoTo(nR)
        DbSkip()
    ENDD
    fDeact( cOldCol )

    //  ⠭ ﭨ । ணࠬ
    zSet( nOrd )
    DbGoTo( nRec )
    RETU
